unit Unit1; {POLYMAP MAKER}
 {
       Soldat Map Maker
        for SOLDAT

 Copyright  2002 Michal Marcinkowski

   free to distribute and modify
 }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, Direct3D8, DX8GFX, ComCtrls, PolyMap, Tools, Menus,
  ToolWin, StdCtrls, ExtCtrls, D3DX8, D3DX8Z, calc, Buttons, D3DFont, Waypoints,
  FileCtrl, ExtDlgs;

const
 VER = '1.2';
 SHORTVER = 11;

type
  TForm1 = class(TForm)
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    CheckBox1: TCheckBox;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    OpenDialog2: TOpenDialog;
    SpawnPointMenu: TPopupMenu;
    All1: TMenuItem;
    Team1: TMenuItem;
    Team2: TMenuItem;
    Undo1: TMenuItem;
    Panel1: TPanel;
    Delete1: TMenuItem;
    Sectors: TToolButton;
    Label1: TLabel;
    SpawnButton: TBitBtn;
    SpeedButton1: TSpeedButton;
    ColliderButton: TBitBtn;
    ColliderMenu: TPopupMenu;
    VerySmall1: TMenuItem;
    Small1: TMenuItem;
    Medium1: TMenuItem;
    Big1: TMenuItem;
    Delete2C: TMenuItem;
    N1: TMenuItem;
    GridButton: TButton;
    GridMenu: TPopupMenu;
    Off1: TMenuItem;
    On11: TMenuItem;
    On21: TMenuItem;
    ON31: TMenuItem;
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    SpeedButton2: TSpeedButton;
    ColorBox1: TColorBox;
    ColorBox2: TColorBox;
    ColorBox3: TColorBox;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    TabSheet4: TTabSheet;
    Label6: TLabel;
    ColorBox4: TColorBox;
    ColorBox5: TColorBox;
    Label8: TLabel;
    Label7: TLabel;
    WaypointBox: TGroupBox;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    leftc: TCheckBox;
    upc: TCheckBox;
    downc: TCheckBox;
    rightc: TCheckBox;
    flyc: TCheckBox;
    path2: TRadioButton;
    Path1: TRadioButton;
    VisionBox: TGroupBox;
    AllC: TRadioButton;
    Path1C: TRadioButton;
    Path2C: TRadioButton;
    GroupBox1: TGroupBox;
    PropBox: TComboBox;
    Label9: TLabel;
    JetBox: TComboBox;
    PolyBox: TComboBox;
    Label10: TLabel;
    Button7: TButton;
    MapName: TEdit;
    Label11: TLabel;
    JetBar: TTrackBar;
    Button8: TButton;
    ScaleXBox: TCheckBox;
    ScaleYBox: TCheckBox;
    AlphaBar: TTrackBar;
    Label12: TLabel;
    N2: TMenuItem;
    eam31: TMenuItem;
    eam41: TMenuItem;
    RedFlag1: TMenuItem;
    Blue1: TMenuItem;
    Grenades1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Medikits1: TMenuItem;
    FlamerBonus1: TMenuItem;
    BerserkerBonus1: TMenuItem;
    PredatorBonus1: TMenuItem;
    ClusterGrenades1: TMenuItem;
    BulletproofVest1: TMenuItem;
    N5: TMenuItem;
    YellowFlag1: TMenuItem;
    RamboBow1: TMenuItem;
    GrenadeBox: TComboBox;
    Label13: TLabel;
    MedicBox: TComboBox;
    Label14: TLabel;
    Label15: TLabel;
    WeatherBox: TComboBox;
    StepBox: TComboBox;
    Label16: TLabel;
    ColorBox6: TColorBox;
    Label17: TLabel;
    Level1: TRadioButton;
    Level2: TRadioButton;
    Level3: TRadioButton;
    Label18: TLabel;
    ToolBar2: TToolBar;
    Darken: TToolButton;
    Stretch: TToolButton;
    SpecialList: TComboBox;
    Label19: TLabel;
    ToolButton6: TToolButton;
    Lighten: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    Button2: TButton;
    Button3: TButton;
    AddCustomSceneryButton: TButton;
    SceneryFiles: TFileListBox;
    SceneryImage: TImage;
    Button1: TButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    HelpPanel: TPanel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    ZoomButton: TButton;
    ZoomBar: TTrackBar;
    GroupBox2: TGroupBox;
    CopyButton: TButton;
    PasteButton: TButton;
    Button9: TButton;
    Button10: TButton;
    N6: TMenuItem;
    Stationarygun1: TMenuItem;
    procedure AppOnIdle(Sender: TObject; var Done: Boolean);
    procedure AppOnActivate(Sender: TObject);
    procedure AppOnDeactivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    function  xLoadTexture(_fn: string; _cKey: TD3DColor;
                        var _text: IDirect3DTexture8): boolean;
    function CreateSpawnPoint(sX,sY,sTeam : integer):integer;
    function CreateProp(sX,sY, Style : integer):integer;
    function CreateCollider(sX,sY, Radius : integer):integer;
    procedure All1Click(Sender: TObject);
    procedure Team1Click(Sender: TObject);
    procedure Team2Click(Sender: TObject);
    procedure SPB1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure SectorsClick(Sender: TObject);
    procedure Division1Click(Sender: TObject);
    procedure ColorBox4Change(Sender: TObject);
    procedure PropsClick(Sender: TObject);
    procedure Make1Click(Sender: TObject);
    procedure Delete2Click(Sender: TObject);
    procedure Style1Click(Sender: TObject);
    procedure Undo2Click(Sender: TObject);
    procedure ColorBox5Change(Sender: TObject);
    procedure SpawnButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure leftcClick(Sender: TObject);
    procedure rightcClick(Sender: TObject);
    procedure upcClick(Sender: TObject);
    procedure downcClick(Sender: TObject);
    procedure flycClick(Sender: TObject);
    procedure Path1Click(Sender: TObject);
    procedure path2Click(Sender: TObject);
    procedure VerySmall1Click(Sender: TObject);
    procedure Small1Click(Sender: TObject);
    procedure Medium1Click(Sender: TObject);
    procedure Big1Click(Sender: TObject);
    procedure Delete2CClick(Sender: TObject);
    procedure ColliderButtonMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GridButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Off1Click(Sender: TObject);
    procedure On11Click(Sender: TObject);
    procedure On21Click(Sender: TObject);
    procedure ON31Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure JetBoxChange(Sender: TObject);
    procedure JetBarChange(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure eam31Click(Sender: TObject);
    procedure eam41Click(Sender: TObject);
    procedure RedFlag1Click(Sender: TObject);
    procedure Blue1Click(Sender: TObject);
    procedure Grenades1Click(Sender: TObject);
    procedure Medikits1Click(Sender: TObject);
    procedure ClusterGrenades1Click(Sender: TObject);
    procedure BulletproofVest1Click(Sender: TObject);
    procedure FlamerBonus1Click(Sender: TObject);
    procedure BerserkerBonus1Click(Sender: TObject);
    procedure PredatorBonus1Click(Sender: TObject);
    procedure YellowFlag1Click(Sender: TObject);
    procedure RamboBow1Click(Sender: TObject);
    procedure SpecialListChange(Sender: TObject);
    procedure PageControlChange(Sender: TObject);
    procedure SceneryFilesChange(Sender: TObject);
    procedure AddCustomScenery(filename : string);
    procedure AddCustomSceneryButtonClick(Sender: TObject);
    procedure ToolButton11Click(Sender: TObject);
    procedure StretchClick(Sender: TObject);
    procedure DarkenClick(Sender: TObject);
    procedure LightenClick(Sender: TObject);
    procedure ToolButton13Click(Sender: TObject);
    procedure ZoomBarChange(Sender: TObject);
    procedure ZoomButtonClick(Sender: TObject);
    procedure CopyButtonClick(Sender: TObject);
    procedure PasteButtonClick(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Stationarygun1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure SaveToFile(filename : string);
   procedure LoadFromFile(filename : string);
   function FindFarest : single;
   procedure FindFarestEdges(var Xl, Xr, Yn, Ys : single);
   function CreateWayPoint(sX,sY : integer):integer;
   procedure UpdateSelPolys;
   procedure ScrollSelPolys(CX, CY: single);
   procedure ScaleSelPolys(SX, SY, CX, CY: single);
   procedure CalcPerps(i : integer);
   procedure SaveToFile2(filename : string);
   procedure LoadFromFile2(filename : string);
   procedure MakeUndo;
  end;

  TCamera = record
   X, Y : integer;
  end;

  TSpawnPoint = record
   Active : boolean;
   X, Y, Team : integer;
  end;

  TOldProp = record
   Active : boolean;
   Style : byte;
   Width, Height : integer;
   X, Y : single;
   Rotation : single;
   ScaleX, ScaleY : single;
   Alpha : byte;
  end;

  TProp = record
   Active : boolean;
   Style : word;
   Width, Height : integer;
   X, Y : single;
   Rotation : single;
   ScaleX, ScaleY : single;
   Alpha : byte;
   Color : longint;
   Level : byte;
  end;


  TPropOld = record
   Active : boolean;
   Style : byte;
   Width, Height : integer;
   X, Y : single;
   Rotation : single;
   ScaleX, ScaleY : single;
   Alpha : byte;
   Color : longint;
   Level : byte;
  end;

  TCollider = record
   Active : boolean;
   X, Y : single;
   Radius : single;
  end;


  //////// OLD MAP FORMAT //////////
   {for file use}
  TAddressRec = record
   Polys : array[1..400] of TPolygon;
   Perp : array[1..400,1..3] of TD3DXVector3;
   PolyCount : integer;
   TextureName : string[24];
   SpawnPoints : array[1..32] of TSpawnPoint;
   Sectors : array[MIN_SECTOR..MAX_SECTOR,MIN_SECTOR..MAX_SECTOR] of TLoadSector;
   SectorsDivision : integer;
   BackgroundColor, BackgroundColor2 : longint;
   Prop : array[1..255] of TOldProp;
   MapRandomID : integer;
   Path : TWaypoints;
   Collider : array[1..128] of TCollider;
  end;

  {for file use}
  TSaveAddressRec = record
   Polys : array[1..400] of TPolygon;
   Perp : array[1..400,1..3] of TD3DXVector3;
   PolyCount : integer;
   TextureName : string[24];
   SpawnPoints : array[1..32] of TSpawnPoint;
   Sectors : array[MIN_SECTOR..MAX_SECTOR,MIN_SECTOR..MAX_SECTOR] of TSaveSector;
   SectorsDivision : integer;
   BackgroundColor, BackgroundColor2 : longint;
   Prop : array[1..255] of TOldProp;
   MapRandomID : integer;
   Path : TWaypoints;
   Collider : array[1..128] of TCollider;
  end;
  //////// OLD MAP FORMAT //////////



{------- save map file structs -------}

 TMapFile_Header = packed record
   Version : integer;
  end;

 TMapFile_Options = packed record
   MapName : string[38];
   TextureName : string[24];
   BackgroundColor, BackgroundColor2 : longint;
   StartJet : integer;
   GrenadePacks, Medikits : byte;
   Weather : byte;
   Steps : byte;
   MapRandomID : integer;
  end;
       {  TMapFile_Options_Old = packed record
           MapName : string[24];
           TextureName : string[24];
           BackgroundColor, BackgroundColor2 : longint;
           StartJet : integer;
           GrenadePacks, Medikits : byte;
           Weather : byte;
           MapRandomID : integer;
          end;   }

 TMapFile_Polygon_Start = packed record
   PolyCount : integer;
  end;

  TMapFile_Polygon = packed record
   Poly : TPolygon;
   Perp : array[1..3] of TD3DXVector3;
   PolyType : byte;
  end;

 TMapFile_Sector_Start = packed record
   SectorsDivision : integer;
   SectorNum : integer;
  end;

  TMapFile_Sector_New = packed record
   PolyCount : word;
  end;

  TMapFile_Sector_PolyNum = packed record
   Polys : word;
  end;

 TMapFile_Prop_Start = packed record
   Num : integer;
  end;

  TMapFile_Prop = packed record
   Prop : TProp;
  end;

      {    TMapFile_Prop_Old = packed record
           Prop : TPropOld;
          end;     }

 TMapFile_Scenery_Start = packed record
   Num : integer;
  end;

  TMapFile_Scenery = packed record
   Name : string[50];
   Date : integer;
  end;

          {TMapFile_Scenery_Old = packed record
           Name : string[38];
          end;   }

 TMapFile_Collider_Start = packed record
   Num : integer;
  end;

  TMapFile_Collider = packed record
   Collider : TCollider;
  end;

 TMapFile_SpawnPoint_Start = packed record
   Num : integer;
  end;

  TMapFile_SpawnPoint = packed record
   SpawnPoint : TSpawnPoint;
  end;

 TMapFile_WayPoint_Start = packed record
   Num : integer;
  end;

  TMapFile_WayPoint = packed record
   WayPoint : TNewWayPoint;
  end;

        {  TMapFile_OldWayPoint = packed record
           WayPoint : TWayPoint;
          end;   }

{------- end map file structs -------}

  function CheckFileDate(filename : string):integer;

var
  Form1: TForm1;

  FRAMECONTROL : dWord;
  DXReady      : boolean = false;
  WindowReady  : boolean = false;
  MX, MY, mmx, mmy : integer;
  dx, dy : single;
  MClick, RClick, LClick : boolean;

  CCount : integer;
  CPointX, CPointY : array[1..3] of single;

  ColPol : integer;
  OnPoly : boolean;

  SpawnPoints : array[1..255] of TSpawnPoint;
  SpawnCreate : boolean =false;
  SpawnDelete : boolean =false;
  SpawnTeam, LastSpawnPoint : integer;

  Prop : array[1..5000] of TProp;
  PropCreate : boolean =false;
  PropDelete : boolean =false;
  PropState : byte;
  PropNum : byte;
  PropStyle : byte;

  Collider : array[1..128] of TCollider;
  ColliderCreate : boolean =false;
  ColliderDelete : boolean =false;
  ColliderRadius : single;

  SKIPCHECK : integer = 5;

  Map : TPolyMap;
  Camera : TCamera;

  SpriteTexture : array[1..15] of IDirect3DTexture8;
  SceneryTexture : array[1..1000] of IDirect3DTexture8;
  SpawnTexture : array[0..16] of IDirect3DTexture8;

  TexName : string[24] = 'banana.bmp';

  fps        : single;
  frp        : integer;
  frc        : integer;

  WireFrame : boolean = false;

  CurrentWaypoint, MouseWaypoint, SelectedWaypoint : integer;
  WaypointMove : boolean = false;
  WayPointsMake : boolean = false;

  Font0 : CD3DFont;

  W1, W2 : integer;

  Grid : boolean = false;
  GridScale : integer = 8;

  UndoPoly : TPolygon;
  UndoPerp : array[1..3] of TD3DXVector3;

  MultiPolNum : integer = 0;
  MultiPol : array[1..500] of integer;

  SinusCounter : integer;

  SelVertexBuffer : IDirect3DVertexBuffer8;
  SelPoly : array[1..500] of TPolygon;
  SelPolyCount : integer = 0;

  SelTexture : IDIRECT3DTEXTURE8;

  CopyPoly : array[1..500] of TPolygon;
  CopyPolyType : array[1..500] of byte;
  CopyPolyCount : integer = 0;

  Zoom : byte = 0;
  ZX, ZY : single;
  OldCX, OldCY : integer;
  OldZCX, OldZCY : integer;

  SWidth, SHeight : array[1..1000] of integer;

  UndoRound : integer = 0;

  SceneryElements : integer=0;

  Compiled : boolean;

  MoveStyle, StretchStyle : integer;

   RootDirectory : string;

// *******************************************************************

const
  WRN00 = 'Error initializing 3D Hardware.'#10+
          'Now software will be used...';
  ERR00 = 'Could not initialize DirectX Graphics.'#10+
          'You must have installed DirectX 8 or better '#10+
          'and a 16, 24 or 32 bpp desktop to run this sample.';
  ERR01 = 'Error initializing Vertex Buffer.';
  ERR02 = 'Error loading map';
  ERR03 = 'Error updating Vertex Buffer.';

  FRAMEAT = 0; // Set to 0 to full speed.

implementation

{$R *.DFM}

// -------------------------------------------------------------------


procedure RenderFrame;
var
 _p, _p2, _r, _s, _scala, c : TD3DXVector2;
 i,j : integer;
 tx, ty : integer;
 Roto : single;
 Si : byte;
 MultiSel : boolean;
 kolor : longint;
begin
  D3DDEV8.Clear(0, NIL, D3DCLEAR_TARGET, $FFFFFF, 1.0, 0);

  // Begin the scene.
  D3DDEV8.BeginScene;

  if Zoom=0 then
  begin
   Map.BackgroundRender;

   Map.Scroll(Camera.X, Camera.Y);
   Form1.ScrollSelPolys(Camera.X, Camera.Y);
  end else
  begin
   Map.BackgroundRender;

   Map.Scale(ZX, ZY, Camera.X, Camera.Y);
   Form1.ScaleSelPolys(ZX, ZY, Camera.X, Camera.Y);
  end;

  D3DXSPR8._Begin;
  // D3DDEV8.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_BLENDDIFFUSEALPHA);

    if Zoom=0 then
    for i:= 1 to 128 do
    if Collider[i].Active then
    begin
     _p.x:= 320-camera.x+Collider[i].X-Collider[i].Radius/2; _p.y:= 240-camera.y+Collider[i].Y-Collider[i].Radius/2;
     if round(Collider[i].Radius)=12 then D3DXDrawSpr(SpriteTexture[9], NIL, @_p, nil, nil, 0, $FFFFFF, 80);
     if round(Collider[i].Radius)=16 then D3DXDrawSpr(SpriteTexture[10], NIL, @_p, nil, nil, 0, $FFFFFF, 80);
     if round(Collider[i].Radius)=24 then D3DXDrawSpr(SpriteTexture[11], NIL, @_p, nil, nil, 0, $FFFFFF, 80);
     if round(Collider[i].Radius)=32 then D3DXDrawSpr(SpriteTexture[12], NIL, @_p, nil, nil, 0, $FFFFFF, 80);
    end;

    for i:= 1 to 5000 do
    if Prop[i].Active then
    if Prop[i].Level<2 then
    if Zoom=0 then
    begin
     _p.x:= 320-camera.x+Prop[i].X; _p.y:= 240-camera.y+Prop[i].Y;
     _r.x:= 0.0; _r.y:= 0.5;
     _s.x:= Prop[i].ScaleX; _s.y:= Prop[i].ScaleY;
     D3DXDrawSpr(SceneryTexture[Prop[i].Style], NIL, @_p, @_s, @_r, Prop[i].Rotation, Prop[i].Color, Prop[i].Alpha);
    end else
    begin
     _p.x:= -Camera.x+Prop[i].X*ZX; _p.y:= -camera.y+Prop[i].Y*ZY;
     _r.x:= 0.0; _r.y:= 0.5;
     _s.x:= Prop[i].ScaleX*ZX; _s.y:= Prop[i].ScaleY*ZY;
     D3DXDrawSpr(SceneryTexture[Prop[i].Style], NIL, @_p, @_s, @_r, Prop[i].Rotation, Prop[i].Color, Prop[i].Alpha);
    end;

  D3DXSPR8._End;

 if Zoom=0 then
 begin
  // Set the stream source.
  D3DDEV8.SetStreamSource( 0, Map.VertexBuffer, sizeof(TCustomVertex));

  // Set the vertex shader.
  D3DDEV8.SetVertexShader(D3DFVF_CUSTOMVERTEX);

  // Set the texture that the will be used to render.
  D3DDEV8.SetTexture(0, Map.Texture);

  // Render the vertices.
  D3DDEV8.DrawPrimitive(D3DPT_TRIANGLELIST, 0, Map.PolyCount);


  D3DDEV8.SetStreamSource( 0, SelVertexBuffer, sizeof(TCustomVertex));
  D3DDEV8.SetVertexShader(D3DFVF_CUSTOMVERTEX);
  D3DDEV8.SetTexture(0, SelTexture);
  D3DDEV8.DrawPrimitive(D3DPT_TRIANGLELIST, 0, SelPolyCount);
 end  else
 begin
  D3DDEV8.SetStreamSource( 0, Map.VertexBuffer, sizeof(TCustomVertex));
  D3DDEV8.SetVertexShader(D3DFVF_CUSTOMVERTEX);
  D3DDEV8.SetTexture(0, Map.Texture);
  D3DDEV8.DrawPrimitive(D3DPT_TRIANGLELIST, 0, Map.PolyCount);

  D3DDEV8.SetStreamSource( 0, SelVertexBuffer, sizeof(TCustomVertex));
  D3DDEV8.SetVertexShader(D3DFVF_CUSTOMVERTEX);
  D3DDEV8.SetTexture(0, SelTexture);
  D3DDEV8.DrawPrimitive(D3DPT_TRIANGLELIST, 0, SelPolyCount);
 end;


  D3DXSPR8._Begin;


  if Grid then
  begin
   tx:= 0;
   ty:= GridScale*4;

   for i:= tx to ty do
    for j:= tx to ty do
    begin
     _scala.x:= GridScale/4;
     _scala.y:= GridScale/4;
     _p.x:= i*150*_scala.y; _p.y:= j*120*_scala.y;
     D3DXDrawSpr(SpriteTexture[13], NIL, @_p, @_Scala, nil, 0, $FFFFFF, 100);
    end;
  end;


    for i:= 1 to 5000 do
    if Prop[i].Active then
    if Prop[i].Level=2 then
    if Zoom=0 then
    begin
     _p.x:= 320-camera.x+Prop[i].X; _p.y:= 240-camera.y+Prop[i].Y;
     _r.x:= 0.0; _r.y:= 0.5;
     _s.x:= Prop[i].ScaleX; _s.y:= Prop[i].ScaleY;
     D3DXDrawSpr(SceneryTexture[Prop[i].Style], NIL, @_p, @_s, @_r, Prop[i].Rotation, Prop[i].Color, Prop[i].Alpha);
    end else
    begin
     _p.x:= -Camera.x+Prop[i].X*ZX; _p.y:= -camera.y+Prop[i].Y*ZY;
     _r.x:= 0.0; _r.y:= 0.5;
     _s.x:= Prop[i].ScaleX*ZX; _s.y:= Prop[i].ScaleY*ZY;
     D3DXDrawSpr(SceneryTexture[Prop[i].Style], NIL, @_p, @_s, @_r, Prop[i].Rotation, Prop[i].Color, Prop[i].Alpha);
    end;

   for i:= 1 to Map.PolyCount do
   begin
    if i=ColPol then
    if Zoom=0 then
    begin
     _p.x:= 320-camera.x+Map.Polys[i].Vertices[1].X-3; _p.y:= 240-camera.y+Map.Polys[i].Vertices[1].Y-3;
      D3DXDrawSpr(SpriteTexture[14], NIL, @_p, NIL, NIL, 0, $33BB33, 240);
     _p.x:= 320-camera.x+Map.Polys[i].Vertices[2].X-3; _p.y:= 240-camera.y+Map.Polys[i].Vertices[2].Y-3;
      D3DXDrawSpr(SpriteTexture[14], NIL, @_p, NIL, NIL, 0, $BBBB33, 240);
     _p.x:= 320-camera.x+Map.Polys[i].Vertices[3].X-3; _p.y:= 240-camera.y+Map.Polys[i].Vertices[3].Y-3;
      D3DXDrawSpr(SpriteTexture[14], NIL, @_p, NIL, NIL, 0, $BB3333, 240);

      si:= 150;

      case Map.PolyType[i] of
       0 : kolor:= $FFFFFF;
       1 : kolor:= $D6ED56;
       2 : kolor:= $99CC33;
       3 : kolor:= $66EE11;
       4 : kolor:= $4444FF;
       5 : kolor:= $FF3333;
       6 : kolor:= $FF1111;
      end;

      _p.x:= 320-camera.x+Map.Polys[i].Vertices[1].X;
      _p.y:= 240-camera.y+Map.Polys[i].Vertices[1].Y;
      _p2.x:= 320-camera.x+Map.Polys[i].Vertices[2].X;
      _p2.y:= 240-camera.y+Map.Polys[i].Vertices[2].Y;
      c:= D3DXVec2Subtract(_p,_p2);
      _scala.x:= D3DXVec2Length(c)/10; _scala.y:=1;
      Roto:= -Angle2Points(_p.x,_p.y,_p2.x,_p2.y);
      D3DXDrawSpr(SpriteTexture[15], NIL, @_p, @_scala, NIL, Roto, kolor, si);

      _p.x:= 320-camera.x+Map.Polys[i].Vertices[2].X;
      _p.y:= 240-camera.y+Map.Polys[i].Vertices[2].Y;
      _p2.x:= 320-camera.x+Map.Polys[i].Vertices[3].X;
      _p2.y:= 240-camera.y+Map.Polys[i].Vertices[3].Y;
      c:= D3DXVec2Subtract(_p,_p2);
      _scala.x:= D3DXVec2Length(c)/10; _scala.y:=1;
      Roto:= -Angle2Points(_p.x,_p.y,_p2.x,_p2.y);
      D3DXDrawSpr(SpriteTexture[15], NIL, @_p, @_scala, NIL, Roto, kolor, si);

      _p.x:= 320-camera.x+Map.Polys[i].Vertices[3].X;
      _p.y:= 240-camera.y+Map.Polys[i].Vertices[3].Y;
      _p2.x:= 320-camera.x+Map.Polys[i].Vertices[1].X;
      _p2.y:= 240-camera.y+Map.Polys[i].Vertices[1].Y;
      c:= D3DXVec2Subtract(_p,_p2);
      _scala.x:= D3DXVec2Length(c)/10; _scala.y:=1;
      Roto:= -Angle2Points(_p.x,_p.y,_p2.x,_p2.y);
      D3DXDrawSpr(SpriteTexture[15], NIL, @_p, @_scala, NIL, Roto, kolor, si);
    end else
    begin
     _p.x:= -camera.x+ZX*Map.Polys[i].Vertices[1].X-6; _p.y:= -camera.y+ZY*Map.Polys[i].Vertices[1].Y-6;
      D3DXDrawSpr(SpriteTexture[14], NIL, @_p, NIL, NIL, 0, $33BB33, 240);
     _p.x:= -camera.x+ZX*Map.Polys[i].Vertices[2].X-6; _p.y:= -camera.y+ZY*Map.Polys[i].Vertices[2].Y-6;
      D3DXDrawSpr(SpriteTexture[14], NIL, @_p, NIL, NIL, 0, $BBBB33, 240);
     _p.x:= -camera.x+ZX*Map.Polys[i].Vertices[3].X-6; _p.y:= -camera.y+ZY*Map.Polys[i].Vertices[3].Y-6;
      D3DXDrawSpr(SpriteTexture[14], NIL, @_p, NIL, NIL, 0, $BB3333, 240);

      si:= 100;

      case Map.PolyType[i] of
       0 : kolor:= $FFFFFF;
       1 : kolor:= $D6ED56;
       2 : kolor:= $99CC33;
       3 : kolor:= $66EE11;
       4 : kolor:= $4444FF;
       5 : kolor:= $FF3333;
       6 : kolor:= $FF1111;
      end;

      _p.x:= -camera.x+ZX*Map.Polys[i].Vertices[1].X;
      _p.y:= -camera.y+ZY*Map.Polys[i].Vertices[1].Y;
      _p2.x:= -camera.x+ZX*Map.Polys[i].Vertices[2].X;
      _p2.y:= -camera.y+ZY*Map.Polys[i].Vertices[2].Y;
      c:= D3DXVec2Subtract(_p,_p2);
      _scala.x:= D3DXVec2Length(c)/10; _scala.y:=1;
      Roto:= -Angle2Points(_p.x,_p.y,_p2.x,_p2.y);
      D3DXDrawSpr(SpriteTexture[15], NIL, @_p, @_scala, NIL, Roto, kolor, si);

      _p.x:= -camera.x+ZX*Map.Polys[i].Vertices[2].X;
      _p.y:= -camera.y+ZY*Map.Polys[i].Vertices[2].Y;
      _p2.x:= -camera.x+ZX*Map.Polys[i].Vertices[3].X;
      _p2.y:= -camera.y+ZY*Map.Polys[i].Vertices[3].Y;
      c:= D3DXVec2Subtract(_p,_p2);
      _scala.x:= D3DXVec2Length(c)/10; _scala.y:=1;
      Roto:= -Angle2Points(_p.x,_p.y,_p2.x,_p2.y);
      D3DXDrawSpr(SpriteTexture[15], NIL, @_p, @_scala, NIL, Roto, kolor, si);

      _p.x:= -camera.x+ZX*Map.Polys[i].Vertices[3].X;
      _p.y:= -camera.y+ZY*Map.Polys[i].Vertices[3].Y;
      _p2.x:= -camera.x+ZX*Map.Polys[i].Vertices[1].X;
      _p2.y:= -camera.y+ZY*Map.Polys[i].Vertices[1].Y;
      c:= D3DXVec2Subtract(_p,_p2);
      _scala.x:= D3DXVec2Length(c)/10; _scala.y:=1;
      Roto:= -Angle2Points(_p.x,_p.y,_p2.x,_p2.y);
      D3DXDrawSpr(SpriteTexture[15], NIL, @_p, @_scala, NIL, Roto, kolor, si);
    end;

  end;


  // D3DDEV8.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_BLENDDIFFUSEALPHA);
    if Zoom=0 then
    for i:= 1 to 255 do
    if SpawnPoints[i].Active then
    begin
     _p.x:= 320-camera.x+SpawnPoints[i].X-16; _p.y:= 240-camera.y+SpawnPoints[i].Y-16;
     D3DXDrawSpr(SpawnTexture[SpawnPoints[i].Team], NIL, @_p, NIL, NIL, 0, $FFFFFF, 250);
    end;

    if SpawnCreate then
    begin
     _p.x:= mmx-16; _p.y:= mmy-16;
     D3DXDrawSpr(SpawnTexture[SpawnTeam], NIL, @_p, NIL, NIL, 0, $FFFFFF, 130);
    end;

    if Zoom=0 then
    if ColliderCreate then
    begin
     _p.x:= mmx-ColliderRadius/2; _p.y:= mmy-ColliderRadius/2;
     if round(ColliderRadius)=12 then D3DXDrawSpr(SpriteTexture[9], NIL, @_p, nil, nil, 0, $FFFFFF, 80);
     if round(ColliderRadius)=16 then D3DXDrawSpr(SpriteTexture[10], NIL, @_p, nil, nil, 0, $FFFFFF, 80);
     if round(ColliderRadius)=24 then D3DXDrawSpr(SpriteTexture[11], NIL, @_p, nil, nil, 0, $FFFFFF, 80);
     if round(ColliderRadius)=32 then D3DXDrawSpr(SpriteTexture[12], NIL, @_p, nil, nil, 0, $FFFFFF, 80);
    end;

    if PropCreate then
    if PropState = 0 then
    begin
     _p.x:= mmx; _p.y:= mmy;
     _Scala.x:= ZX; _Scala.y:= ZY;
     if Zoom>0 then
     D3DXDrawSpr(SceneryTexture[PropStyle], NIL, @_p, @_scala, NIL, 0, $FFFFFF, 130) else
     D3DXDrawSpr(SceneryTexture[PropStyle], NIL, @_p, NIL, NIL, 0, $FFFFFF, 130);
    end;

    if Zoom=0 then
   if WayPointsMake then
   begin

    for i:= 1 to MAX_WAYPOINTS do
    if Map.Path.Waypoint[i].Active then
    begin
     _p.x:= 320-camera.x+Map.Path.Waypoint[i].X-7; _p.y:= 240-camera.y+Map.Path.Waypoint[i].Y-7;
     if Map.Path.Waypoint[i].PathNum=1 then
     begin
      if (form1.Path1C.Checked)or(form1.AllC.Checked) then
      D3DXDrawSpr(SpriteTexture[5], NIL, @_p, NIL, NIL, 0, $FFFFFF, 250)
     end else
     if (form1.Path2C.Checked)or(form1.AllC.Checked) then
     D3DXDrawSpr(SpriteTexture[8], NIL, @_p, NIL, NIL, 0, $889988, 250);

     if i=MouseWaypoint then
      D3DXDrawSpr(SpriteTexture[6], NIL, @_p, NIL, NIL, 0, $FFFFFF, 255);
    end;


    for i:= 1 to 500 do
    if Map.Path.Waypoint[i].Active then
    if Map.Path.Waypoint[i].ConnectionsNum<21 then
    for J:= 1 to Map.Path.Waypoint[i].ConnectionsNum do
    if (Map.Path.Waypoint[i].Connections[J]>0)and(Map.Path.Waypoint[i].Connections[J]<500) then
    begin
     if ((Map.Path.Waypoint[i].PathNum=1)and(Map.Path.Waypoint[Map.Path.Waypoint[i].Connections[J]].PathNum=1)and((form1.Path1C.Checked)or(form1.AllC.Checked)))
     or((Map.Path.Waypoint[i].PathNum=2)and(Map.Path.Waypoint[Map.Path.Waypoint[i].Connections[J]].PathNum=2)and((form1.Path2C.Checked)or(form1.AllC.Checked)))
     or ((Map.Path.Waypoint[i].PathNum=1)and(Map.Path.Waypoint[Map.Path.Waypoint[i].Connections[J]].PathNum=2))
     or ((Map.Path.Waypoint[i].PathNum=2)and(Map.Path.Waypoint[Map.Path.Waypoint[i].Connections[J]].PathNum=1))
      then
     begin
     _p.x:= 320-camera.x+Map.Path.Waypoint[i].X;
     _p.y:= 240-camera.y+Map.Path.Waypoint[i].Y;
     _p2.x:= 320-camera.x+Map.Path.Waypoint[Map.Path.Waypoint[i].Connections[J]].X;
     _p2.y:= 240-camera.y+Map.Path.Waypoint[Map.Path.Waypoint[i].Connections[J]].Y;
     c:= D3DXVec2Subtract(_p,_p2);
     _scala.x:= D3DXVec2Length(c)/5; _scala.y:=1;
     Roto:= -Angle2Points(_p.x,_p.y,_p2.x,_p2.y);
     D3DXDrawSpr(SpriteTexture[7], NIL, @_p, @_scala, NIL, Roto, $DDDDDD, 125);
     if Map.Path.Waypoint[Map.Path.Waypoint[i].Connections[J]].Left then
      D3DXDrawSpr(SpriteTexture[7], NIL, @_p, @_scala, NIL, Roto, $22FF22, 250);
     if Map.Path.Waypoint[Map.Path.Waypoint[i].Connections[J]].Right then
     D3DXDrawSpr(SpriteTexture[7], NIL, @_p, @_scala, NIL, Roto, $FF2222, 250);
     if Map.Path.Waypoint[Map.Path.Waypoint[i].Connections[J]].Up then
     D3DXDrawSpr(SpriteTexture[7], NIL, @_p, @_scala, NIL, Roto, $FFFF22, 250);
     if Map.Path.Waypoint[Map.Path.Waypoint[i].Connections[J]].Down then
     D3DXDrawSpr(SpriteTexture[7], NIL, @_p, @_scala, NIL, Roto, $22FFFF, 250);
    end;
    end;
   end;



  D3DXSPR8._End;
  // *****************************************************************

   {if WaypointsMake then
    for i:= 1 to MAX_WAYPOINTS do
    if Map.Path.Waypoint[i].Active then
    begin
     _p.x:= 320-camera.x+Map.Path.Waypoint[i].X-4;
     _p.y:= 240-camera.y+Map.Path.Waypoint[i].Y-2;
     Font0.DrawText(_p.x, _p.y, D3DCOLOR_ARGB(150,248,155,90), pchar(inttostr(Map.Path.Waypoint[i].ID)),0);
     _p.x:= 320-camera.x+Map.Path.Waypoint[i].X-4;
     _p.y:= 240-camera.y+Map.Path.Waypoint[i].Y+8;
     Font0.DrawText(_p.x, _p.y, D3DCOLOR_ARGB(150,88,255,90), pchar(inttostr(Map.Path.Waypoint[i].FindNum)),0);

     if Map.Path.Waypoint[i].ConnectionsNum>0 then
     for j:= 1 to Map.Path.Waypoint[i].ConnectionsNum do
     begin
      _p.y:= _p.y+15;
      Font0.DrawText(_p.x, _p.y, D3DCOLOR_ARGB(150,158,205,230), pchar(inttostr(Map.Path.Waypoint[i].Connections[j])),0);
     end;
    end;         }


  // End the scene.
  D3DDEV8.EndScene;

  // Display scene.
  D3DDEV8.Present(NIL, NIL, 0, NIL);
end;

// -------------------------------------------------------------------


function  TForm1.xLoadTexture(_fn: string; _cKey: TD3DColor;
                       var _text: IDirect3DTexture8): boolean;

begin
  _text := NIL;
  _text := D3DXLoadTextureFromFile(pChar(_fn), _cKey);
  Result := (_text <> NIL); 
end;

procedure hHalt(_errMsg: pChar);

begin
  MessageBox(0, _errMsg, 'Error', MB_ICONERROR);
  Application.Terminate;
end;




//////////////////////////////////
//////// MAIN PROGRAM ////////////
//////////////////////////////////
procedure TForm1.AppOnIdle(Sender: TObject; var Done: Boolean);
var
 i, j : integer;
 V1, V2, V3 : TD3DXVector2;
 C1, C2, C3 : longint;
 Temp : Integer;
 Temp2: String;
 Scroll : boolean;
 sm : string[38];
 d : single;
 Kolor : longint;
 R, G, B : integer;
 RK, GK, BK : single;
begin
  Done := false;
  if (not DXReady) or (not WindowReady) then exit;

 Temp:= ColorToRGB(ColorBox1.Selected);
 Temp2 := IntToHex(temp,6);
 C1:= strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2));
 Temp:= ColorToRGB(ColorBox2.Selected);
 Temp2 := IntToHex(temp,6);
 C2:= strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2));
 Temp:= ColorToRGB(ColorBox3.Selected);
 Temp2 := IntToHex(temp,6);
 C3:= strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2));


  if WaypointMove then
  begin
   Map.Path.Waypoint[MouseWaypoint].X:= mx;
   Map.Path.Waypoint[MouseWaypoint].Y:= my;
  end;


  {do polygon @ cursor}
  if CCount=1 then
  begin
   Map.Polys[Map.PolyCount].Vertices[2] := GetCustomVertex(MX, MY, 0.5, 1, 0.0, 0.0, C2, Camera.X, Camera.Y);
   Map.Polys[Map.PolyCount].Vertices[3] := GetCustomVertex(MX-1, MY+1, 0.5, 1, 0.0, 0.0, C3, Camera.X, Camera.Y);
   if not Map.UpdateVertexBuffer then begin hHalt(ERR03); exit; end;
  end;

  if CCount=2 then
  begin
   Map.Polys[Map.PolyCount].Vertices[3] := GetCustomVertex(MX, MY, 0.5, 1, 0.0, 0.0, C3, Camera.X, Camera.Y);
   if not Map.UpdateVertexBuffer then begin hHalt(ERR03); exit; end;
  end;

 if (MClick)and(MultiPolNum>0)and(not SpawnCreate)and(not SpawnDelete)and(not PropCreate)and(not ColliderCreate)and(not PropDelete)and(not ColliderDelete)and(not WaypointsMake) then
 begin
  V2.X:= dx; V2.Y:= dy;
  Compiled:= false;

  if MultiPolNum>0 then
  begin
   for j:= 1 to MultiPolNum do
   begin
    with Map.Polys[MultiPol[j]] do
    for i:= 1 to 3 do
    begin
     V1:= D3DXVector2(Vertices[i].X,Vertices[i].Y);
     V3:= D3DXVec2Add(V1, V2);
     Vertices[i].X:= V3.X; Vertices[i].Y:= V3.Y;
    end; {with Polys / for j}

     Map.Polys[MultiPol[j]].Vertices[1]:= GetCustomVertex(Map.Polys[MultiPol[j]].Vertices[1].X, Map.Polys[MultiPol[j]].Vertices[1].Y, 1, 1, Map.Polys[MultiPol[j]].Vertices[1].tu, Map.Polys[MultiPol[j]].Vertices[1].tv, Map.Polys[MultiPol[j]].Vertices[1].DColor, Camera.X, Camera.Y);
     Map.Polys[MultiPol[j]].Vertices[2]:= GetCustomVertex(Map.Polys[MultiPol[j]].Vertices[2].X, Map.Polys[MultiPol[j]].Vertices[2].Y, 1, 1, Map.Polys[MultiPol[j]].Vertices[2].tu, Map.Polys[MultiPol[j]].Vertices[2].tv, Map.Polys[MultiPol[j]].Vertices[2].DColor, Camera.X, Camera.Y);
     Map.Polys[MultiPol[j]].Vertices[3]:= GetCustomVertex(Map.Polys[MultiPol[j]].Vertices[3].X, Map.Polys[MultiPol[j]].Vertices[3].Y, 1, 1, Map.Polys[MultiPol[j]].Vertices[3].tu, Map.Polys[MultiPol[j]].Vertices[3].tv, Map.Polys[MultiPol[j]].Vertices[3].DColor, Camera.X, Camera.Y);
   end;

     UpdateSelPolys;
  end;

  Map.UpdateVertexBuffer;
 end else
 if (MClick)and(ColPol>0)and(not SpawnCreate)and(not SpawnDelete)and(not PropCreate)and(not ColliderCreate)and(not PropDelete)and(not ColliderDelete)and(not WaypointsMake) then
 begin
  V2.X:= dx; V2.Y:= dy;
                         Compiled:= false;
   Scroll:= false;
  with Map.Polys[ColPol] do
  for i:= 1 to 3 do
  if (Distance(MX,MY,Vertices[i].X,Vertices[i].Y)<10)or(MoveStyle>0) then
  begin
   if MoveStyle=0 then MoveStyle:= i;
   V1:= D3DXVector2(Vertices[MoveStyle].X,Vertices[MoveStyle].Y);
   V3:= D3DXVec2Add(V1, V2);
   Vertices[MoveStyle].X:= V3.X; Vertices[MoveStyle].Y:= V3.Y;
   Scroll:= true;
   CalcPerps(ColPol);
   break;
  end; {with Polys / for j}

  if not Scroll then            ////// ONPOLY !!!!!!!!!!
  with Map.Polys[ColPol] do
  for i:= 1 to 3 do
  begin
   V1:= D3DXVector2(Vertices[i].X,Vertices[i].Y);
   V3:= D3DXVec2Add(V1, V2);
   Vertices[i].X:= V3.X; Vertices[i].Y:= V3.Y;
  end; {with Polys / for j}

  Map.Polys[ColPol].Vertices[1]:= GetCustomVertex(Map.Polys[ColPol].Vertices[1].X, Map.Polys[ColPol].Vertices[1].Y, 1, 1, Map.Polys[ColPol].Vertices[1].tu, Map.Polys[ColPol].Vertices[1].tv, Map.Polys[ColPol].Vertices[1].DColor, Camera.X, Camera.Y);
  Map.Polys[ColPol].Vertices[2]:= GetCustomVertex(Map.Polys[ColPol].Vertices[2].X, Map.Polys[ColPol].Vertices[2].Y, 1, 1, Map.Polys[ColPol].Vertices[2].tu, Map.Polys[ColPol].Vertices[2].tv, Map.Polys[ColPol].Vertices[2].DColor, Camera.X, Camera.Y);
  Map.Polys[ColPol].Vertices[3]:= GetCustomVertex(Map.Polys[ColPol].Vertices[3].X, Map.Polys[ColPol].Vertices[3].Y, 1, 1, Map.Polys[ColPol].Vertices[3].tu, Map.Polys[ColPol].Vertices[3].tv, Map.Polys[ColPol].Vertices[3].DColor, Camera.X, Camera.Y);

  Map.UpdateVertexBuffer;
 end else
 if RClick then
 begin
  if Zoom=0 then
  begin
   Camera.X:= round(Camera.X-1*DX);
   Camera.Y:= round(Camera.Y-1*DY);
  end else
  begin
//   Camera.X:= Camera.X-1*DX;
//   Camera.Y:= Camera.Y-1*DY;
   Camera.X:= round(Camera.X-ZX*DX);
   Camera.Y:= round(Camera.Y-ZY*DY);
  end;
 end;



 if LClick then
 if (Stretch.Down)or(Darken.Down)or(Lighten.Down) then
 begin

  if ColPol=0 then
  for i:= 1 to Map.PolyCount do
  begin

   for j:= 1 to 3 do
   if Distance(mx, my, Map.Polys[i].Vertices[j].X, Map.Polys[i].Vertices[j].Y)<81 then
   begin
     if (Darken.Down)or(Lighten.Down) then
     begin
      d:= Distance(mx, my, Map.Polys[i].Vertices[j].X, Map.Polys[i].Vertices[j].Y);

      if Darken.Down then
      begin
       RK:= 0.99;
       GK:= 0.99;
       BK:= 0.99;
      end;
      if Lighten.Down then
      begin
       RK:= 1.01;
       GK:= 1.01;
       BK:= 1.01;
      end;

      R:= round(getBValue(Map.Polys[i].Vertices[j].DColor) * (RK)+(81/d)/70);
      if R>255 then R:= 255;
      G:= round(getGValue(Map.Polys[i].Vertices[j].DColor) * (GK)+(81/d)/70);
      if G>255 then G:= 255;
      B:= round(getRValue(Map.Polys[i].Vertices[j].DColor) * (BK)+(81/d)/70);
      if B>255 then B:= 255;
      Kolor:= RGB(R,G,B);

      Temp:= ColorToRGB(Kolor);
      Temp2 := IntToHex(temp,6);

      Map.Polys[i].Vertices[j]:= GetCustomVertex(Map.Polys[i].Vertices[j].X, Map.Polys[i].Vertices[j].Y, 1, 1, Map.Polys[i].Vertices[j].tu , Map.Polys[i].Vertices[j].tv, strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2)), Camera.X, Camera.Y);
     end;

     if Stretch.Down then
     begin
      V1.x:= Map.Polys[i].Vertices[j].tu  -  DX/100;
      V1.y:= Map.Polys[i].Vertices[j].tv  -  DY/100;
      Map.Polys[i].Vertices[j]:= GetCustomVertex(Map.Polys[i].Vertices[j].X, Map.Polys[i].Vertices[j].Y, 1, 1, V1.X , V1.Y, Map.Polys[i].Vertices[j].DColor, Camera.X, Camera.Y);
     end;

   end;
  end;

   if ColPol>0 then
   begin
     if (not Stretch.Down) then StretchStyle:= j;
   i:= ColPol;
   for j:= 1 to 3 do
   if (Distance(mx, my, Map.Polys[i].Vertices[j].X, Map.Polys[i].Vertices[j].Y)<251)or(StretchStyle>0) then
   begin
     if StretchStyle=0 then StretchStyle:= j;

     if (Darken.Down)or(Lighten.Down) then
     if Distance(mx, my, Map.Polys[i].Vertices[StretchStyle].X, Map.Polys[i].Vertices[StretchStyle].Y)<51 then
     begin
      d:= Distance(mx, my, Map.Polys[i].Vertices[StretchStyle].X, Map.Polys[i].Vertices[StretchStyle].Y);

      if Darken.Down then
      begin
       RK:= 0.99;
       GK:= 0.99;
       BK:= 0.99
      end;
      if Lighten.Down then
      begin
       RK:= 1.01;
       GK:= 1.01;
       BK:= 1.01;
      end;

      R:= round(getBValue(Map.Polys[i].Vertices[StretchStyle].DColor) * (RK)+(81/d)/70);
      if R>255 then R:= 255;
      G:= round(getGValue(Map.Polys[i].Vertices[StretchStyle].DColor) * (GK)+(81/d)/70);
      if G>255 then G:= 255;
      B:= round(getRValue(Map.Polys[i].Vertices[StretchStyle].DColor) * (BK)+(81/d)/70);
      if B>255 then B:= 255;
      Kolor:= RGB(R ,G,B);

      Temp:= ColorToRGB(Kolor);
      Temp2 := IntToHex(temp,6);

      Map.Polys[i].Vertices[StretchStyle]:= GetCustomVertex(Map.Polys[i].Vertices[StretchStyle].X, Map.Polys[i].Vertices[StretchStyle].Y, 1, 1, Map.Polys[i].Vertices[StretchStyle].tu , Map.Polys[i].Vertices[StretchStyle].tv, strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2)), Camera.X, Camera.Y);
     end;

     if Stretch.Down then
     begin
      V1.x:= Map.Polys[i].Vertices[StretchStyle].tu  -  DX/100;
      V1.y:= Map.Polys[i].Vertices[StretchStyle].tv  -  DY/100;
      Map.Polys[i].Vertices[StretchStyle]:= GetCustomVertex(Map.Polys[i].Vertices[StretchStyle].X, Map.Polys[i].Vertices[StretchStyle].Y, 1, 1, V1.X , V1.Y, Map.Polys[i].Vertices[StretchStyle].DColor, Camera.X, Camera.Y);
     end;

   end;
   end;

  Map.UpdateVertexBuffer;
 end;


 DX:= 0; DY:= 0;

 if Zoom>0 then
 begin
  OldZCX:= Camera.X; OldZCY:= Camera.Y;
 end else
 begin
  OldCX:= Camera.X; OldCY:= Camera.Y;
 end;


  { - /- /- / - }

  RenderFrame;

 //label1.caption:= inttostr(round(mx))+' '+inttostr(round(my)) +' C:' +inttostr(Map.Sectors[round(mx/Map.SectorsDivision),round(my/Map.SectorsDivision)].PolyCount);
 //label1.repaint;

 if WaypointsMake then Label1.Caption:= '- Making Waypoints' else
 if SpawnCreate then Label1.Caption:= '- Placing Spawn Point' else
 if PropCreate then Label1.Caption:= '- Making Scenery' else
 if ColliderCreate then Label1.Caption:= '- Making Colliders' else
 begin
  Label1.Caption:= '- Making Polygons';
  if CCount>0 then
   Label1.Caption:= '- Making Polygon: Vertice '+inttostr(CCount){+'  -  '+inttostr(Map.PolyCount)+'/'+inttostr(MaxPolys2)};
 end;

  // Speed control
  while GetTickCount - FRAMECONTROL < FRAMEAT do Sleep(0);
  FRAMECONTROL := GetTickCount;

       { FPS Handling }
    inc(frc);
    if frc = 25 then
    begin
      frc := 0;
      fps := frp;
      frp := GetTickCount;
      fps := 25000/(frp-fps);
//      sm:= MapName.Text;
      Caption := Application.Title+'   version '+VER+'   - (FPS: '+FloatToStrF(fps, ffFixed, 7, 0)+')  - '+sm;
//      Caption := inttostr(mx)+'  '+inttostr(my)+' ---- '+inttostr(camera.y)+'  '+inttostr(camera.y);
    end;
end;

// ------------------------------------------------------------------

procedure TForm1.AppOnActivate(Sender: TObject);

begin
  WindowReady := true;
end;

// ------------------------------------------------------------------

procedure TForm1.AppOnDeactivate(Sender: TObject);

begin
  WindowReady := false;
end;



/////////////////////////////////////////////
//////// PROGRAM LOAD AND ACITVATE //////////
/////////////////////////////////////////////
procedure TForm1.FormActivate(Sender: TObject);
var
 i, j, k : integer;
 _ptr : pByte;
 II : TD3DXImageInfo;
begin
  FRAMECONTROL := GetTickCount;

  // Initialize application events
  Application.OnIdle       := AppOnIdle;
  Application.OnActivate   := AppOnActivate;
  Application.OnDeactivate := AppOnDeactivate;
  Application.OnRestore    := AppOnActivate;
  Application.OnMinimize   := AppOnDeActivate;

  RootDirectory:= extractfiledir(Application.ExeName)+'\';

  // Initialize Direct Graphics (first try with Hardware Accel. (HAL))
  if not InitDGfx(Panel1.Handle, false, 0, 0, 0, 0, true, false, false) then
    begin
      MessageBox(0, WRN00, 'Warning.', MB_ICONWARNING);
      CloseDGfx;
      if not InitDGfx(Panel1.Handle, false, 0, 0, 0, 0, false, false, false) then
        begin hHalt(ERR00); exit; end;
    end;

  // Initialize D3DX interfaces.
  if not InitD3DX then begin hHalt(ERR01); exit; end;

  // Initialize Map
  if not Map.Initialize then begin hHalt(ERR01); exit; end;

    Map.LoadTexture(RootDirectory+'..\Textures\banana.bmp');

  for i:= 1 to 5000 do SpawnPoints[i].Active:= false;

  // Disable culling.
  D3DDEV8.SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);

  // Disable lights.
  D3DDEV8.SetRenderState(D3DRS_LIGHTING, 0);

  // Set ambiental light.
//  D3DDEV8.SetRenderState(D3DRS_AMBIENT, $F04A40);

 // D3DDEV8.SetTextureStageState(0, D3DTSS_MAGFILTER, ord(D3DTEXF_LINEAR));
 // D3DDEV8.SetTextureStageState(0, D3DTSS_MINFILTER, ord(D3DTEXF_LINEAR));

{  if not xLoadTexture('ALL.BMP',  $FF00FF00, SpriteTexture[1]) then exit;
  if not xLoadTexture('T1.BMP',  $FF00FF00, SpriteTexture[2]) then exit;
  if not xLoadTexture('T2.BMP',  $FF00FF00, SpriteTexture[3]) then exit;
  if not xLoadTexture('BACK.BMP',  $FF00FF00, SpriteTexture[4]) then exit;}
  if not xLoadTexture(RootDirectory+'GFX\WAYPOINT.BMP',  $FF00FF00, SpriteTexture[5]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\WAYPOINT2.BMP',  $FF00FF00, SpriteTexture[6]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\BULLET.BMP',  $FF00FF00, SpriteTexture[7]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\WAYPOINT3.BMP',  $FF00FF00, SpriteTexture[8]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\COLLIDER0.BMP',  $FF00FF00, SpriteTexture[9]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\COLLIDER1.BMP',  $FF00FF00, SpriteTexture[10]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\COLLIDER2.BMP',  $FF00FF00, SpriteTexture[11]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\COLLIDER3.BMP',  $FF00FF00, SpriteTexture[12]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\GRID.BMP',  $FF00FF00, SpriteTexture[13]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\VERT.BMP',  $FF00FF00, SpriteTexture[14]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\LINE.BMP',  $FF00FF00, SpriteTexture[15]) then exit;
                                     
  if not xLoadTexture(RootDirectory+'GFX\0.BMP',  $FF00FF00, SpawnTexture[0]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\1.BMP',  $FF00FF00, SpawnTexture[1]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\2.BMP',  $FF00FF00, SpawnTexture[2]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\3.BMP',  $FF00FF00, SpawnTexture[3]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\4.BMP',  $FF00FF00, SpawnTexture[4]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\5.BMP',  $FF00FF00, SpawnTexture[5]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\6.BMP',  $FF00FF00, SpawnTexture[6]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\7.BMP',  $FF00FF00, SpawnTexture[7]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\8.BMP',  $FF00FF00, SpawnTexture[8]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\9.BMP',  $FF00FF00, SpawnTexture[9]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\10.BMP',  $FF00FF00, SpawnTexture[10]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\11.BMP',  $FF00FF00, SpawnTexture[11]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\12.BMP',  $FF00FF00, SpawnTexture[12]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\13.BMP',  $FF00FF00, SpawnTexture[13]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\14.BMP',  $FF00FF00, SpawnTexture[14]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\15.BMP',  $FF00FF00, SpawnTexture[15]) then exit;
  if not xLoadTexture(RootDirectory+'GFX\16.BMP',  $FF00FF00, SpawnTexture[16]) then exit;

  // All ok
  DXReady := true;

 for i:= 1 to 5000 do SpawnPoints[i].Active:= false;

 for i:= NMIN_SECTOR to NMAX_SECTOR do
  for j:= NMIN_SECTOR to NMAX_SECTOR do
  begin
   Map.Sectors[i,j].PolyCount:= 0;
   for k:= 1 to 200 do
    Map.Sectors[i,j].Polys[k]:= 0;
  end;

   for i:= 1 to MAX_WAYPOINTS do
    Map.Path.Waypoint[i].ConnectionsNum:= 0;

    Map.SectorsDivision:= 300;

  //other
  CCount:= 0;
  Camera.X:= 0; Camera.Y:= 0;

  PropStyle:= 1;

   Font0:= CD3DFont.Create('Lucida Console', 7, 0);
   Font0.InitDeviceObjects(D3DDEV8);
   Font0.RestoreDeviceObjects;


  // Create a vertex buffer.
  if failed(D3DDEV8.CreateVertexBuffer(SizeOf(SelPoly), 0,
                                       D3DFVF_CUSTOMVERTEX,
                                       D3DPOOL_DEFAULT,
                                       SelVertexBuffer)) then exit;

  // Lock, fill and unlock vertex buffer.
  if failed(SelVertexBuffer.Lock(0, SizeOf(SelPoly), _ptr, 0)) then exit;
  Move(SelPoly, _ptr^, SizeOf(SelPoly));
  SelVertexBuffer.Unlock;
  SelPolyCount:= 0;

 if( FAILED( D3DXCreateTextureFromFile( D3DDEV8, PChar(RootDirectory+'GFX\cytryna.bmp'),
                                      SelTexture ) ) ) then
   begin
    MessageBox(0, 'Cannot load texture', 'Error', MB_ICONERROR);
    exit;
   end;


  JetBox.ItemIndex:= 4;
  PolyBox.ItemIndex:= 0;
  WeatherBox.ItemIndex:= 0;
  StepBox.ItemIndex:= 0;
  SpecialList.ItemIndex:= 0;
  OldCX:= 0; OldCY:= 0;
  OldZCX:= 0; OldZCY:= 0;

  SceneryFiles.ApplyFilePath(RootDirectory+'..\Scenery-gfx');
  OpenDialog.InitialDir:= RootDirectory+'..\Maps';
  OpenDialog2.InitialDir:= RootDirectory+'..\Textures';

  Compiled:= false;
  UndoRound:= -1;
end;

// -------------------------------------------------------------------

procedure TForm1.FormDestroy(Sender: TObject);
var j : integer;
begin
  DXReady := false;

  for j:= 1 to 15 do
   SpriteTexture[j] := NIL;

  for j:= 1 to 1000 do
   SceneryTexture[j] := NIL;

   Font0:= nil;

  SelVertexBuffer:= nil;

  // Free Map
  Map.Destroy;
  // Free DX
  CloseDGfx;
end;

// -------------------------------------------------------------------
////////    ON MOUSE UP //////////////////////////////////////////////
// -------------------------------------------------------------------
procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
 T : TCustomVertex;
 V, V1, V2 : TD3DXVector3;
 _v0, _v1, _v2, U : TD3DXVector3;
 _edge1, _edge2, _edge3 : TD3DXVector3;
 C1, C2, C3 : longint;
 Temp, i, j : Integer;
 Temp2: String;
 P, P2 : TD3DXVector2;
 D : single;
 Color : longint;
 CX, CY : integer;
begin

 if Button=mbRight then RClick:= false;
 if (Button=mbLeft){and(ssShift in Shift)} then MClick:= false;
 if Button=mbLeft then LClick:= false;

   MoveStyle:= 0;  StretchStyle:= 0;

 //  if Zoom then exit;

 if Zoom=0 then
 begin
  CX:= X-320+camera.x;
  CY:= Y-240+camera.y;
 end else
 begin
  CX:= round((X+camera.x)/ZX);
  CY:= round((Y+camera.y)/ZY);
 end;


if (Button=mbLeft)and(CCount=0)and(not MClick)and(not(ssAlt in Shift))and(not(ssCtrl in Shift))and(not(ssShift in Shift))and(not SpawnCreate)and(not SpawnDelete)and(not PropCreate)and(not ColliderCreate)and(not PropDelete)and(not ColliderDelete)and(not WaypointsMake)and(not Stretch.Down)and(not Darken.Down)and(not Lighten.Down) then
begin
 for i:= 1 to Map.PolyCount do
  if Map.PointInPoly(MX,MY, i) then
  begin
   ColPol:= i; OnPoly:= true;
   MultiPolNum:= 0;
   UpdateSelPolys;
   CheckBox1.Caption:= 'Selected Poly: '+inttostr(i);
   CheckBox1.Checked:= true;
   break;
  end else
  begin
   ColPol:= 0; OnPoly:= false;
   MultiPolNum:= 0;
   UpdateSelPolys;
   CheckBox1.Caption:= 'No Poly Selected';
   CheckBox1.Checked:= false;
  end;

  Stretch.Down:= false;
  Darken.Down:= false;
  Lighten.Down:= false;
   exit;
end;

 if Button=mbLeft then
 begin
  Stretch.Down:= false;
  Darken.Down:= false;
  Lighten.Down:= false;
 end;

if (Button=mbLeft)and(ssAlt in Shift)and(not WaypointsMake) then
begin
 for i:= 1 to Map.PolyCount do
  if Map.PointInPoly(MX,MY, i) then
  begin
   for j:= 1 to MultiPolNum do
    if MultiPol[j]=i then
    begin
     MultiPol[j]:= MultiPol[MultiPolNum];
     dec(MultiPolNum);
     CheckBox1.Caption:= 'Selected number: '+inttostr(MultiPolNum);
     UpdateSelPolys;
     exit;
    end;

   ColPol:= 0; OnPoly:= false;
   inc(MultiPolNum);
   MultiPol[MultiPolNum]:= i;
   CheckBox1.Caption:= 'Selected number: '+inttostr(MultiPolNum);
   UpdateSelPolys;
   exit;
  end;

end;

if (Button=mbRight)and(ssCtrl in Shift)and(not WaypointsMake) then
begin
  MakeUndo;

 if ColPol>0 then
 begin
  Map.Polys[ColPol]:= Map.Polys[Map.PolyCount];
  Map.Perp[ColPol,1]:= Map.Perp[Map.PolyCount,1];
  Map.Perp[ColPol,2]:= Map.Perp[Map.PolyCount,2];
  Map.Perp[ColPol,3]:= Map.Perp[Map.PolyCount,3];
  dec(Map.Polycount);
  ColPol:= 0;
  Map.UpdateVertexBuffer;
 end;

 if MultiPolNum>0 then
 for j:= 1 to MultiPolNum do
 begin
  Map.Polys[MultiPol[j]]:= Map.Polys[Map.PolyCount];
  Map.Perp[MultiPol[j],1]:= Map.Perp[Map.PolyCount,1];
  Map.Perp[MultiPol[j],2]:= Map.Perp[Map.PolyCount,2];
  Map.Perp[MultiPol[j],3]:= Map.Perp[Map.PolyCount,3];
  dec(Map.Polycount);
  MultiPolNum:= 0;
  UpdateSelPolys;
  Map.UpdateVertexBuffer;
 end;
end;


if (Button=mbRight)and(ssShift in Shift)and(not WaypointsMake) then
if (ColPol>0)and(ColPol<Map.PolyCount+1) then
if Map.PolyCount<MaxPolys2 then
begin
  MakeUndo;   Compiled:= false;

 P.X:= CX;
 P.Y:= CY;

 j:= Map.ClosestPerpendicular(ColPol, P, D);

 UndoPoly:= Map.Polys[ColPol];
 UndoPerp[1]:= Map.Perp[ColPol][1];
 UndoPerp[2]:= Map.Perp[ColPol][2];
 UndoPerp[3]:= Map.Perp[ColPol][3];

 inc(Map.PolyCount);
 Map.Polys[Map.PolyCount].Vertices[1] := GetCustomVertex(Map.Polys[ColPol].Vertices[1].X, Map.Polys[ColPol].Vertices[1].Y, 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[1].DColor, Camera.X, Camera.Y);
 Map.Polys[Map.PolyCount].Vertices[2] := GetCustomVertex(Map.Polys[ColPol].Vertices[2].X, Map.Polys[ColPol].Vertices[2].Y, 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[2].DColor, Camera.X, Camera.Y);
 Map.Polys[Map.PolyCount].Vertices[3] := GetCustomVertex(Map.Polys[ColPol].Vertices[3].X, Map.Polys[ColPol].Vertices[3].Y, 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[3].DColor, Camera.X, Camera.Y);

 if j=1 then
 begin
  Map.Polys[Map.PolyCount].Vertices[1] := GetCustomVertex(round(CX), round(CY), 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[2].DColor, Camera.X, Camera.Y);
  Map.Polys[ColPol].Vertices[1] := GetCustomVertex(Map.Polys[ColPol].Vertices[1].X, Map.Polys[ColPol].Vertices[1].Y, 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[1].DColor, Camera.X, Camera.Y);
   Map.Polys[ColPol].Vertices[2] := GetCustomVertex(round(CX), round(CY), 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[2].DColor, Camera.X, Camera.Y);
  Map.Polys[ColPol].Vertices[3] := GetCustomVertex(Map.Polys[ColPol].Vertices[3].X, Map.Polys[ColPol].Vertices[3].Y, 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[3].DColor, Camera.X, Camera.Y);
 end;
 if j=2 then
 begin
  Map.Polys[Map.PolyCount].Vertices[2] := GetCustomVertex(round(CX), round(CY), 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[3].DColor, Camera.X, Camera.Y);
  Map.Polys[ColPol].Vertices[1] := GetCustomVertex(Map.Polys[ColPol].Vertices[1].X, Map.Polys[ColPol].Vertices[1].Y, 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[1].DColor, Camera.X, Camera.Y);
  Map.Polys[ColPol].Vertices[2] := GetCustomVertex(Map.Polys[ColPol].Vertices[2].X, Map.Polys[ColPol].Vertices[2].Y, 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[2].DColor, Camera.X, Camera.Y);
   Map.Polys[ColPol].Vertices[3] := GetCustomVertex(round(CX), round(CY), 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[3].DColor, Camera.X, Camera.Y);
 end;
 if j=3 then
 begin
  Map.Polys[Map.PolyCount].Vertices[3] := GetCustomVertex(round(CX), round(CY), 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[1].DColor, Camera.X, Camera.Y);
   Map.Polys[ColPol].Vertices[1] := GetCustomVertex(round(CX), round(CY), 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[1].DColor, Camera.X, Camera.Y);
  Map.Polys[ColPol].Vertices[2] := GetCustomVertex(Map.Polys[ColPol].Vertices[2].X, Map.Polys[ColPol].Vertices[2].Y, 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[2].DColor, Camera.X, Camera.Y);
  Map.Polys[ColPol].Vertices[3] := GetCustomVertex(Map.Polys[ColPol].Vertices[3].X, Map.Polys[ColPol].Vertices[3].Y, 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[3].DColor, Camera.X, Camera.Y);
 end;

  Map.PolyType[Map.PolyCount]:= Map.PolyType[ColPol]; 
  CalcPerps(Map.PolyCount);
  CalcPerps(ColPol);

 Map.UpdateVertexBuffer;
end;


if (Button=mbLeft)and((ssCtrl in Shift)or(CCount>0))and(not(ssShift in Shift))and(not SpawnCreate)and(not SpawnDelete)and(not PropCreate)and(not ColliderCreate)and(not PropDelete)and(not ColliderDelete)and(not WaypointsMake) then
{boundaries} //if (mx>(MIN_SECTOR*Map.SectorsDivision))and(mx<(MAX_SECTOR*Map.SectorsDivision))and(my>(MIN_SECTOR*Map.SectorsDivision))and(my<(MAX_SECTOR*Map.SectorsDivision)) then
begin
 if Map.PolyCount>=MaxPolys2 then exit;
                         Compiled:= false;
 inc(CCount);
 CPointX[CCount]:= CX;
 CPointY[CCount]:= CY;

 for i:= 1 to MaxPolys2 do
 if i<>Map.PolyCount then
 for j:= 1 to 3 do
 if (abs(Map.Polys[i].Vertices[j].X-CPointX[CCount])<5)and(abs(Map.Polys[i].Vertices[j].Y-CPointY[CCount])<5) then
 begin
  CPointX[CCount]:= Map.Polys[i].Vertices[j].X;
  CPointY[CCount]:= Map.Polys[i].Vertices[j].Y;
 end;

 Temp:= ColorToRGB(ColorBox1.Selected);
 Temp2 := IntToHex(temp,6);
 C1:= strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2));
 Temp:= ColorToRGB(ColorBox2.Selected);
 Temp2 := IntToHex(temp,6);
 C2:= strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2));
 Temp:= ColorToRGB(ColorBox3.Selected);
 Temp2 := IntToHex(temp,6);
 C3:= strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2));

  if CCount=1 then
  begin {draw polygon on mouse}
   MakeUndo;
   inc(Map.PolyCount);
   Map.Polys[Map.PolyCount].Vertices[1] := GetCustomVertex(round(CPointX[1]), round(CPointY[1]), 1, 1, 0.0, 0.0, C1, Camera.X, Camera.Y);
  end;

  if CCount=2 then
   Map.Polys[Map.PolyCount].Vertices[2] := GetCustomVertex(round(CPointX[2]), round(CPointY[2]), 1, 1, 0.0, 0.0, C2, Camera.X, Camera.Y);

  if CCount=3 then
  begin {make polygon}
    Map.Polys[Map.PolyCount].Vertices[3] := GetCustomVertex(round(CPointX[3]), round(CPointY[3]), 1, 1, 0.0, 0.0, C3, Camera.X, Camera.Y);
   CCount:= 0;

   {check if counterclockwise - crossproduct}
   if (((Map.Polys[Map.PolyCount].Vertices[2].X - Map.Polys[Map.PolyCount].Vertices[1].X) * (Map.Polys[Map.PolyCount].Vertices[3].Y - Map.Polys[Map.PolyCount].Vertices[2].Y))
- ((Map.Polys[Map.PolyCount].Vertices[2].Y - Map.Polys[Map.PolyCount].Vertices[1].Y) * (Map.Polys[Map.PolyCount].Vertices[3].X - Map.Polys[Map.PolyCount].Vertices[2].X)))<0 then
    begin
     T:= Map.Polys[Map.PolyCount].Vertices[2];
     Map.Polys[Map.PolyCount].Vertices[2]:= Map.Polys[Map.PolyCount].Vertices[1];
     Map.Polys[Map.PolyCount].Vertices[1]:= T;
    end;

    //////// CALC PERPENDICULARS //////

  {_v0.x:= Map.Polys[Map.PolyCount].Vertices[1].X; _v0.y:=Map.Polys[Map.PolyCount].Vertices[1].Y;
  _v1.x:= Map.Polys[Map.PolyCount].Vertices[2].X; _v1.y:= Map.Polys[Map.PolyCount].Vertices[2].Y;
  _v2.x:= Map.Polys[Map.PolyCount].Vertices[3].X; _v2.y:= Map.Polys[Map.PolyCount].Vertices[3].Y;

  _edge1.x := _v1.x - _v0.x;  _edge1.y := _v1.y - _v0.y;
  Map.Perp[Map.PolyCount][1].X:= -_edge1.Y;  Map.Perp[Map.PolyCount][1].Y:= _edge1.X;
  D3DXVec3Normalize(Map.Perp[Map.PolyCount][1],Map.Perp[Map.PolyCount][1]);

  _edge2.x := _v2.x - _v1.x;  _edge2.y := _v2.y - _v1.y;
  Map.Perp[Map.PolyCount][2].X:= -_edge2.Y;  Map.Perp[Map.PolyCount][2].Y:= _edge2.X;
  D3DXVec3Normalize(Map.Perp[Map.PolyCount][2],Map.Perp[Map.PolyCount][2]);

  _edge3.x := _v0.x - _v2.x;  _edge3.y := _v0.y - _v2.y;
  Map.Perp[Map.PolyCount][3].X:= -_edge3.Y;  Map.Perp[Map.PolyCount][3].Y:= _edge3.X;
  D3DXVec3Normalize(Map.Perp[Map.PolyCount][3],Map.Perp[Map.PolyCount][3]);  }

   CalcPerps(Map.PolyCount);

    {    0 Normal
    1 only bullets
    2 only player
    3 doesn't
    4 ice
    5 deadly
    6 bloody deadly
    7 hurts
    8 regenerates
    9 lava
       }
    Map.PolyType[Map.PolyCount]:= PolyBox.ItemIndex;

   if not Map.UpdateVertexBuffer then exit;
  end;
end; {mbleft}

if (Button=mbLeft)and(SpawnCreate)and(not WaypointsMake) then
begin
  MakeUndo;

 LastSpawnPoint:= CreateSpawnPoint(mx,my,SpawnTeam);
 SpawnCreate:= false;
end;

if (Button=mbLeft)and(SpawnDelete)and(not WaypointsMake) then
begin
  MakeUndo;

   for i:= 1 to 5000 do
   if SpawnPoints[i].Active then
   if (mx>SpawnPoints[i].X-9)and(mx<SpawnPoints[i].X+9)and(my>SpawnPoints[i].Y-9)and(my<SpawnPoints[i].Y+9) then
   SpawnPoints[i].Active:= false;

 SpawnDelete:= false;
end;


if (Button=mbLeft)and(PropDelete)and(not WaypointsMake) then
begin
  MakeUndo;

   for i:= 1 to 5000 do
   if Prop[i].Active then
   if (mx>(Prop[i].X-Prop[i].Width))and(mx<(Prop[i].X+Prop[i].Width))and(my>(Prop[i].Y-Prop[i].Height))and(my<(Prop[i].Y+Prop[i].Height)) then
    Prop[i].Active:= false;

 PropDelete:= false;
end;

if (Button=mbLeft)and(ColliderDelete)and(not WaypointsMake) then
begin
  MakeUndo;

   for i:= 1 to 128 do
   if Collider[i].Active then
   if Distance(mx, my, Collider[i].X, Collider[i].Y)<Collider[i].Radius then
    Collider[i].Active:= false;

 ColliderDelete:= false;
end;

if (Button=mbLeft)and(PropCreate)and(not WaypointsMake) then
begin
 inc(PropState);

 if PropState = 1 then
 begin
  MakeUndo;
  PropNum:= CreateProp(mx, my, PropStyle);
  Prop[PropNum].Alpha:= AlphaBar.Position;
 end;

 if PropState = 2 then
 begin
  PropCreate:= false;
 end;

end;


if (Button=mbLeft)and(ColliderCreate)and(not WaypointsMake) then
begin
  MakeUndo;

  CreateCollider(mx, my, round(ColliderRadius));
  ColliderCreate:= false;
end;



   WaypointMove:= false;

 if (WaypointsMake)and(Button=mbRight)and(ssShift in Shift) then
 begin
  MakeUndo;

  if (MouseWaypoint>0) then
  begin
   for i:= 1 to MAX_WAYPOINTS do
   if Map.Path.Waypoint[i].Active then
   if (mx>Map.Path.Waypoint[i].X-7)and(mx<Map.Path.Waypoint[i].X+7)and(my>Map.Path.Waypoint[i].Y-7)and(my<Map.Path.Waypoint[i].Y+7) then
   if i<>MouseWaypoint then
   if (AllC.Checked)or(((Map.Path.Waypoint[i].PathNum=1)and(Path1C.Checked))or((Map.Path.Waypoint[i].PathNum=2)and(Path2C.Checked))) then
   begin
    SelectedWaypoint:= i;

    inc(Map.Path.Waypoint[MouseWaypoint].ConnectionsNum);
    Map.Path.Waypoint[MouseWaypoint].Connections[Map.Path.Waypoint[MouseWaypoint].ConnectionsNum]:= SelectedWaypoint;
    MouseWaypoint:= i;
    SelectedWaypoint:= 0;
    exit;
   end else SelectedWaypoint:= 0;

  end;
 end;


 if (WaypointsMake)and(Button=mbLeft)and(ssCtrl in Shift)and(not (ssShift in Shift)) then
 begin
  MakeUndo;

    CurrentWaypoint:= CreateWayPoint(mx, my);
    MouseWaypoint:= CurrentWaypoint;
     if Path1.Checked then Map.Path.WayPoint[MouseWaypoint].PathNum:=1;
     if Path2.Checked then Map.Path.WayPoint[MouseWaypoint].PathNum:=2;
 end;

 if (WaypointsMake)and(Button=mbLeft)and(not (ssShift in Shift)) then
 begin
   for i:= 1 to MAX_WAYPOINTS do
   if Map.Path.Waypoint[i].Active then
   if (mx>Map.Path.Waypoint[i].X-7)and(mx<Map.Path.Waypoint[i].X+7)and(my>Map.Path.Waypoint[i].Y-7)and(my<Map.Path.Waypoint[i].Y+7) then
   begin
    if (AllC.Checked)or(((Map.Path.Waypoint[i].PathNum=1)and(Path1C.Checked))or((Map.Path.Waypoint[i].PathNum=2)and(Path2C.Checked))) then
    begin

    MouseWaypoint:= i;

     UpC.Checked:= Map.Path.WayPoint[MouseWaypoint].Up;
     DownC.Checked:= Map.Path.WayPoint[MouseWaypoint].Down;
     LeftC.Checked:= Map.Path.WayPoint[MouseWaypoint].Left;
     RightC.Checked:= Map.Path.WayPoint[MouseWaypoint].Right;
     FlyC.Checked:= Map.Path.WayPoint[MouseWaypoint].M2;
     SpecialList.ItemIndex:= Map.Path.WayPoint[MouseWaypoint].C1;
     if Map.Path.WayPoint[MouseWaypoint].PathNum=1 then Path1.Checked:= true;
     if Map.Path.WayPoint[MouseWaypoint].PathNum=2 then Path2.Checked:= true;
    end else exit;
    exit;
   end else MouseWaypoint:= 0;
 end;


 if (WaypointsMake)and(Button=mbRight)and(ssCtrl in Shift) then
 begin
  MakeUndo;

  SpeedButton3Click(self);
 end;
end;


// -------------------------------------------------------------------
////////    ON MOUSE MOVE //////////////////////////////////////////////
// -------------------------------------------------------------------
procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var
   i, j : integer;
   d : single;
   Temp : Integer;
   Temp2: String;
   Kolor : TColor;
begin
 dx:= x-mmx; dy:= y-mmy;
 mx:= x+camera.x-320; my:= y+camera.y-240;

 if Zoom>0 then
 begin
  mx:= round((x+camera.x)/ZX);
  my:= round((y+camera.y)/ZY);
  dx:= (x-mmx)/ZX; dy:= (y-mmy)/ZY;
 end;

 mmx:= x; mmy:= y;

 if (PropCreate)and(PropState=1) then
 begin
  Prop[PropNum].Rotation:= -Angle2Points(Prop[PropNum].x, Prop[PropNum].y, mx,my);
  if ScaleXBox.Checked then
   Prop[PropNum].ScaleX:= Distance(Prop[PropNum].x, Prop[PropNum].y, mx,my)/Prop[PropNum].Width;
  if ScaleYBox.Checked then
   Prop[PropNum].ScaleY:= Distance(Prop[PropNum].x, Prop[PropNum].y, mx,my)/Prop[PropNum].Height;
 end;

end;


// -------------------------------------------------------------------
////////    OLD FILE FORMAT SAVING ///////////////////////////////////
// -------------------------------------------------------------------
procedure TForm1.SaveToFile(filename : string);
var
  AddrFile  : file of TSaveAddressRec;
  AddrRec   : TSaveAddressRec;
  i, k, j : integer;
  s : string;
begin

 {assign Map to AddrRec}
  AddrRec.PolyCount:= Map.PolyCount;
 for i:= 1 to Map.Polycount do
  AddrRec.Polys[i]:= Map.Polys[i];
 for i:= 1 to Map.Polycount do
 begin
  AddrRec.Perp[i][1]:= Map.Perp[i][1];
  AddrRec.Perp[i][2]:= Map.Perp[i][2];
  AddrRec.Perp[i][3]:= Map.Perp[i][3];
 end;

  AddrRec.TextureName:= TexName;

 for i:= 1 to 32 do
 begin
  AddrRec.SpawnPoints[i]:= SpawnPoints[i];
 end;

 for i:= 1 to 255 do
 begin
  AddrRec.Prop[i].Active:= Prop[i].Active;
  AddrRec.Prop[i].Style:= Prop[i].Style;
  AddrRec.Prop[i].Width:= Prop[i].Width;
  AddrRec.Prop[i].Height:= Prop[i].Height;
  AddrRec.Prop[i].X:= Prop[i].X;
  AddrRec.Prop[i].Y:= Prop[i].Y;
  AddrRec.Prop[i].Rotation:= Prop[i].Rotation;
  AddrRec.Prop[i].ScaleX:= Prop[i].ScaleX;
  AddrRec.Prop[i].ScaleY:= Prop[i].ScaleY;
  AddrRec.Prop[i].Alpha:= Prop[i].Alpha;
 end;

 for i:= 1 to 128 do
 begin
  AddrRec.Collider[i]:= Collider[i];
 end;

 for i:= MIN_SECTOR to MAX_SECTOR do
  for j:= MIN_SECTOR to MAX_SECTOR do
 //  AddrRec.Sectors[i,j]:= Map.Sectors[i,j];
  for k:= 1 to 200 do
  begin
   AddrRec.Sectors[i,j].Polys[k]:= Map.Sectors[i,j].Polys[k];
   AddrRec.Sectors[i,j].PolyCount:= Map.Sectors[i,j].PolyCount;
  end;

  // AddrRec.Path:= Map.Path;

   AddrRec.SectorsDivision:= Map.SectorsDivision;

   AddrRec.BackgroundColor:= Map.BackgroundColor;
   AddrRec.BackgroundColor2:= Map.BackgroundColor2;

   randomize;
   AddrRec.MapRandomID:= random(1000000);

  s:= extractfilename(Filename);
  if length(s)>20 then
  begin
   showmessage('Map filename too long. Map not saved');
   exit;
  end;

 AssignFile(AddrFile, s);
 Rewrite(AddrFile);
  {write it!}
   Write(AddrFile, AddrRec);
 CloseFile(AddrFile);

end;

// -------------------------------------------------------------------
////////    OLD FILE FORMAT LOADING ///////////////////////////////////
// -------------------------------------------------------------------
procedure TForm1.LoadFromFile(filename : string);
var
  AddrFile  : File of TAddressRec;
  AddrRec   : TAddressRec;
  i, j, k : integer;
  color : TColor;
  s : string;
  II : TD3DXImageInfo;
begin
 AssignFile(AddrFile, Filename);
 Reset(AddrFile);
  {read it!}
   Read(AddrFile, AddrRec);
 CloseFile(AddrFile);

   for j:= 1 to MAX_WAYPOINTS do
   Map.Path.Waypoint[j].Active:= false;

   for i:= 1 to MAX_WAYPOINTS do
    Map.Path.Waypoint[i].ConnectionsNum:= 0;

 { s:= OpenDialog.FileName;
  delete(s, length(OpenDialog.FileName)-3, 4);
 Map.Path.LoadFromFile(s+'.WAY'); }
    

  Map.PolyCount:= AddrRec.PolyCount;
 for i:= 1 to AddrRec.Polycount do
  Map.Polys[i]:= AddrRec.Polys[i];
 for i:= 1 to AddrRec.Polycount do
 begin
  Map.Perp[i][1]:= AddrRec.Perp[i][1];
  Map.Perp[i][2]:= AddrRec.Perp[i][2];
  Map.Perp[i][3]:= AddrRec.Perp[i][3];
 end;

 for i:= 1 to 32 do
 begin
  SpawnPoints[i]:= AddrRec.SpawnPoints[i];
 end;

 for i:= 1 to 255 do
 begin
  Prop[i].Active:=  AddrRec.Prop[i].Active;
  Prop[i].Style:=  AddrRec.Prop[i].Style;
  Prop[i].Width:=  AddrRec.Prop[i].Width;
  Prop[i].Height:=  AddrRec.Prop[i].Height;
  Prop[i].X:=  AddrRec.Prop[i].X;
  Prop[i].Y:=  AddrRec.Prop[i].Y;
  Prop[i].Rotation:=  AddrRec.Prop[i].Rotation;
  Prop[i].ScaleX:=  AddrRec.Prop[i].ScaleX;
  Prop[i].ScaleY:=  AddrRec.Prop[i].ScaleY;
  Prop[i].Alpha:=  255;
  Prop[i].Color:= $FFFFFF;
  Prop[i].Level:= 1;
 end;

  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\GRASS.BMP',  $FF00FF00, SceneryTexture[1]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\GRASS.BMP'), II); SWidth[1]:= II.Width; SHeight[1]:= II.Height;
PropBox.Items.Add('GRASS.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\GRASS2.BMP',  $FF00FF00, SceneryTexture[2]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\GRASS2.BMP'), II); SWidth[2]:= II.Width; SHeight[2]:= II.Height;
PropBox.Items.Add('GRASS2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\GRASS3.BMP',  $FF00FF00, SceneryTexture[3]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\GRASS3.BMP'), II); SWidth[3]:= II.Width; SHeight[3]:= II.Height;
PropBox.Items.Add('GRASS3.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\GRASS4.BMP',  $FF00FF00, SceneryTexture[4]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\GRASS4.BMP'), II); SWidth[4]:= II.Width; SHeight[4]:= II.Height;
PropBox.Items.Add('GRASS4.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\LIANA.BMP',  $FF00FF00, SceneryTexture[5]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\LIANA.BMP'), II); SWidth[5]:= II.Width; SHeight[5]:= II.Height;
PropBox.Items.Add('LIANA.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\LIANA2.BMP',  $FF00FF00, SceneryTexture[6]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\LIANA2.BMP'), II); SWidth[6]:= II.Width; SHeight[6]:= II.Height;
PropBox.Items.Add('LIANA2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\FENCE.BMP',  $FF00FF00, SceneryTexture[7]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\FENCE.BMP'), II); SWidth[7]:= II.Width; SHeight[7]:= II.Height;
PropBox.Items.Add('FENCE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\RUBBLE.BMP',  $FF00FF00, SceneryTexture[8]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\RUBBLE.BMP'), II); SWidth[8]:= II.Width; SHeight[8]:= II.Height;
PropBox.Items.Add('RUBBLE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\RUBBLE2.BMP',  $FF00FF00, SceneryTexture[9]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\RUBBLE2.BMP'), II); SWidth[9]:= II.Width; SHeight[9]:= II.Height;
PropBox.Items.Add('RUBBLE2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\RUBBLE3.BMP',  $FF00FF00, SceneryTexture[10]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\RUBBLE3.BMP'), II); SWidth[10]:= II.Width; SHeight[10]:= II.Height;
PropBox.Items.Add('RUBBLE3.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\COL.BMP',  $FF00FF00, SceneryTexture[11]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\COL.BMP'), II); SWidth[11]:= II.Width; SHeight[11]:= II.Height;
PropBox.Items.Add('COL.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\COL2.BMP',  $FF00FF00, SceneryTexture[12]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\COL2.BMP'), II); SWidth[12]:= II.Width; SHeight[12]:= II.Height;
PropBox.Items.Add('COL2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\COL3.BMP',  $FF00FF00, SceneryTexture[13]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\COL3.BMP'), II); SWidth[13]:= II.Width; SHeight[13]:= II.Height;
PropBox.Items.Add('COL3.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\ROCKS.BMP',  $FF00FF00, SceneryTexture[14]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\ROCKS.BMP'), II); SWidth[14]:= II.Width; SHeight[14]:= II.Height;
PropBox.Items.Add('ROCKS.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\LIANA3.BMP',  $FF00FF00, SceneryTexture[15]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\LIANA3.BMP'), II); SWidth[15]:= II.Width; SHeight[15]:= II.Height;
PropBox.Items.Add('LIANA3.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\ROCKS2.BMP',  $FF00FF00, SceneryTexture[16]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\ROCKS2.BMP'), II); SWidth[16]:= II.Width; SHeight[16]:= II.Height;
PropBox.Items.Add('ROCKS2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BARREL.BMP',  $FF00FF00, SceneryTexture[17]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BARREL.BMP'), II); SWidth[17]:= II.Width; SHeight[17]:= II.Height;
PropBox.Items.Add('BARREL.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\GARBISH.BMP',  $FF00FF00, SceneryTexture[18]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\GARBISH.BMP'), II); SWidth[18]:= II.Width; SHeight[18]:= II.Height;
PropBox.Items.Add('GARBISH.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\SMALLCRATE.BMP',  $FF00FF00, SceneryTexture[19]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\SMALLCRATE.BMP'), II); SWidth[19]:= II.Width; SHeight[19]:= II.Height;
PropBox.Items.Add('SMALLCRATE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\SANDBAGS.BMP',  $FF00FF00, SceneryTexture[20]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\SANDBAGS.BMP'), II); SWidth[20]:= II.Width; SHeight[20]:= II.Height;
PropBox.Items.Add('SANDBAGS.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BIGCRATE.BMP',  $FF00FF00, SceneryTexture[21]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BIGCRATE.BMP'), II); SWidth[21]:= II.Width; SHeight[21]:= II.Height;
PropBox.Items.Add('BIGCRATE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BUNKER.BMP',  $FF00FF00, SceneryTexture[22]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BUNKER.BMP'), II); SWidth[22]:= II.Width; SHeight[22]:= II.Height;
PropBox.Items.Add('BUNKER.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\OBSTACLE.BMP',  $FF00FF00, SceneryTexture[23]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\OBSTACLE.BMP'), II); SWidth[23]:= II.Width; SHeight[23]:= II.Height;
PropBox.Items.Add('OBSTACLE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\OBSTACLE2.BMP',  $FF00FF00, SceneryTexture[24]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\OBSTACLE2.BMP'), II); SWidth[24]:= II.Width; SHeight[24]:= II.Height;
PropBox.Items.Add('OBSTACLE2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BUSH.BMP',  $FF00FF00, SceneryTexture[25]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BUSH.BMP'), II); SWidth[25]:= II.Width; SHeight[25]:= II.Height;
PropBox.Items.Add('BUSH.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BUSH2.BMP',  $FF00FF00, SceneryTexture[26]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BUSH2.BMP'), II); SWidth[26]:= II.Width; SHeight[26]:= II.Height;
PropBox.Items.Add('BUSH2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BUSH3.BMP',  $FF00FF00, SceneryTexture[27]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BUSH3.BMP'), II); SWidth[27]:= II.Width; SHeight[27]:= II.Height;
PropBox.Items.Add('BUSH3.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BUSH4.BMP',  $FF00FF00, SceneryTexture[28]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BUSH4.BMP'), II); SWidth[28]:= II.Width; SHeight[28]:= II.Height;
PropBox.Items.Add('BUSH4.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BUSH5.BMP',  $FF00FF00, SceneryTexture[29]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BUSH5.BMP'), II); SWidth[29]:= II.Width; SHeight[29]:= II.Height;
PropBox.Items.Add('BUSH5.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BUSH6.BMP',  $FF00FF00, SceneryTexture[30]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BUSH6.BMP'), II); SWidth[30]:= II.Width; SHeight[30]:= II.Height;
PropBox.Items.Add('BUSH6.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\TREE.BMP',  $FF00FF00, SceneryTexture[31]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\TREE.BMP'), II); SWidth[31]:= II.Width; SHeight[31]:= II.Height;
PropBox.Items.Add('TREE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\TREE2.BMP',  $FF00FF00, SceneryTexture[32]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\TREE2.BMP'), II); SWidth[32]:= II.Width; SHeight[32]:= II.Height;
PropBox.Items.Add('TREE2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\TREE3.BMP',  $FF00FF00, SceneryTexture[33]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\TREE3.BMP'), II); SWidth[33]:= II.Width; SHeight[33]:= II.Height;
PropBox.Items.Add('TREE3.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\TREE4.BMP',  $FF00FF00, SceneryTexture[34]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\TREE4.BMP'), II); SWidth[34]:= II.Width; SHeight[34]:= II.Height;
PropBox.Items.Add('TREE4.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\TREE5.BMP',  $FF00FF00, SceneryTexture[35]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\TREE5.BMP'), II); SWidth[35]:= II.Width; SHeight[35]:= II.Height;
PropBox.Items.Add('TREE5.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\TREE6.BMP',  $FF00FF00, SceneryTexture[36]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\TREE6.BMP'), II); SWidth[36]:= II.Width; SHeight[36]:= II.Height;
PropBox.Items.Add('TREE6.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\TREE7.BMP',  $FF00FF00, SceneryTexture[37]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\TREE7.BMP'), II); SWidth[37]:= II.Width; SHeight[37]:= II.Height;
PropBox.Items.Add('TREE7.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\ROOTS.BMP',  $FF00FF00, SceneryTexture[38]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\ROOTS.BMP'), II); SWidth[38]:= II.Width; SHeight[38]:= II.Height;
PropBox.Items.Add('ROOTS.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BARBWIRE.BMP',  $FF00FF00, SceneryTexture[39]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BARBWIRE.BMP'), II); SWidth[39]:= II.Width; SHeight[39]:= II.Height;
PropBox.Items.Add('BARBWIRE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\COL4.BMP',  $FF00FF00, SceneryTexture[40]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\COL4.BMP'), II); SWidth[40]:= II.Width; SHeight[40]:= II.Height;
PropBox.Items.Add('COL4.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\SANDBAGS2.BMP',  $FF00FF00, SceneryTexture[41]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\SANDBAGS2.BMP'), II); SWidth[41]:= II.Width; SHeight[41]:= II.Height;
PropBox.Items.Add('SANDBAGS2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\JUNGLETREE.BMP',  $FF00FF00, SceneryTexture[42]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\JUNGLETREE.BMP'), II); SWidth[42]:= II.Width; SHeight[42]:= II.Height;
PropBox.Items.Add('JUNGLETREE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\JUNGLETREE2.BMP',  $FF00FF00, SceneryTexture[43]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\JUNGLETREE2.BMP'), II); SWidth[43]:= II.Width; SHeight[43]:= II.Height;
PropBox.Items.Add('JUNGLETREE2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\JUNGLEBUSH.BMP',  $FF00FF00, SceneryTexture[44]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\JUNGLEBUSH.BMP'), II); SWidth[44]:= II.Width; SHeight[44]:= II.Height;
PropBox.Items.Add('JUNGLEBUSH.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\JUNGLEBUSH2.BMP',  $FF00FF00, SceneryTexture[45]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\JUNGLEBUSH2.BMP'), II); SWidth[45]:= II.Width; SHeight[45]:= II.Height;
PropBox.Items.Add('JUNGLEBUSH2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\JUNGLEBUSH3.BMP',  $FF00FF00, SceneryTexture[46]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\JUNGLEBUSH3.BMP'), II); SWidth[46]:= II.Width; SHeight[46]:= II.Height;
PropBox.Items.Add('JUNGLEBUSH3.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\JUNGLEBUSH4.BMP',  $FF00FF00, SceneryTexture[47]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\JUNGLEBUSH4.BMP'), II); SWidth[47]:= II.Width; SHeight[47]:= II.Height;
PropBox.Items.Add('JUNGLEBUSH4.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BRANCHES.BMP',  $FF00FF00, SceneryTexture[48]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BRANCHES.BMP'), II); SWidth[48]:= II.Width; SHeight[48]:= II.Height;
PropBox.Items.Add('BRANCHES.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\JUNGLEBUSH5.BMP',  $FF00FF00, SceneryTexture[49]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\JUNGLEBUSH5.BMP'), II); SWidth[49]:= II.Width; SHeight[49]:= II.Height;
PropBox.Items.Add('JUNGLEBUSH5.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\GRASS5.BMP',  $FF00FF00, SceneryTexture[50]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\GRASS5.BMP'), II); SWidth[50]:= II.Width; SHeight[50]:= II.Height;
PropBox.Items.Add('GRASS5.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\GRASS6.BMP',  $FF00FF00, SceneryTexture[51]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\GRASS6.BMP'), II); SWidth[51]:= II.Width; SHeight[51]:= II.Height;
PropBox.Items.Add('GRASS6.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\LIANA4.BMP',  $FF00FF00, SceneryTexture[52]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\LIANA4.BMP'), II); SWidth[52]:= II.Width; SHeight[52]:= II.Height;
PropBox.Items.Add('LIANA4.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BAMBOODOOR.BMP',  $FF00FF00, SceneryTexture[53]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BAMBOODOOR.BMP'), II); SWidth[53]:= II.Width; SHeight[53]:= II.Height;
PropBox.Items.Add('BAMBOODOOR.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\COL5.BMP',  $FF00FF00, SceneryTexture[54]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\COL5.BMP'), II); SWidth[54]:= II.Width; SHeight[54]:= II.Height;
PropBox.Items.Add('COL5.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\COL6.BMP',  $FF00FF00, SceneryTexture[55]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\COL6.BMP'), II); SWidth[55]:= II.Width; SHeight[55]:= II.Height;
PropBox.Items.Add('COL6.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BARREL2.BMP',  $FF00FF00, SceneryTexture[56]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BARREL2.BMP'), II); SWidth[56]:= II.Width; SHeight[56]:= II.Height;
PropBox.Items.Add('BARREL2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\CAMONET.BMP',  $FF00FF00, SceneryTexture[57]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\CAMONET.BMP'), II); SWidth[57]:= II.Width; SHeight[57]:= II.Height;
PropBox.Items.Add('CAMONET.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\CAMONET2.BMP',  $FF00FF00, SceneryTexture[58]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\CAMONET2.BMP'), II); SWidth[58]:= II.Width; SHeight[58]:= II.Height;
PropBox.Items.Add('CAMONET2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\CRATE.BMP',  $FF00FF00, SceneryTexture[59]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\CRATE.BMP'), II); SWidth[59]:= II.Width; SHeight[59]:= II.Height;
PropBox.Items.Add('CRATE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\CRATE2.BMP',  $FF00FF00, SceneryTexture[60]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\CRATE2.BMP'), II); SWidth[60]:= II.Width; SHeight[60]:= II.Height;
PropBox.Items.Add('CRATE2.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\CRATE3.BMP',  $FF00FF00, SceneryTexture[61]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\CRATE3.BMP'), II); SWidth[61]:= II.Width; SHeight[61]:= II.Height;
PropBox.Items.Add('CRATE3.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\CRATE4.BMP',  $FF00FF00, SceneryTexture[62]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\CRATE4.BMP'), II); SWidth[62]:= II.Width; SHeight[62]:= II.Height;
PropBox.Items.Add('CRATE4.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\CRATEBOX.BMP',  $FF00FF00, SceneryTexture[63]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\CRATEBOX.BMP'), II); SWidth[63]:= II.Width; SHeight[63]:= II.Height;
PropBox.Items.Add('CRATEBOX.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\FOLIAGE.BMP',  $FF00FF00, SceneryTexture[64]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\FOLIAGE.BMP'), II); SWidth[64]:= II.Width; SHeight[64]:= II.Height;
PropBox.Items.Add('FOLIAGE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\BARREL3.BMP',  $FF00FF00, SceneryTexture[65]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\BARREL3.BMP'), II); SWidth[65]:= II.Width; SHeight[65]:= II.Height;
PropBox.Items.Add('BARREL3.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\SANDBAGS3.BMP',  $FF00FF00, SceneryTexture[66]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\SANDBAGS3.BMP'), II); SWidth[66]:= II.Width; SHeight[66]:= II.Height;
PropBox.Items.Add('SANDBAGS3.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\SANDBAGS4.BMP',  $FF00FF00, SceneryTexture[67]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\SANDBAGS4.BMP'), II); SWidth[67]:= II.Width; SHeight[67]:= II.Height;
PropBox.Items.Add('SANDBAGS4.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\JUNGLEFLORA.BMP',  $FF00FF00, SceneryTexture[68]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\JUNGLEFLORA.BMP'), II); SWidth[68]:= II.Width; SHeight[68]:= II.Height;
PropBox.Items.Add('JUNGLEFLORA.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\WOODFENCE.BMP',  $FF00FF00, SceneryTexture[69]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\WOODFENCE.BMP'), II); SWidth[69]:= II.Width; SHeight[69]:= II.Height;
PropBox.Items.Add('WOODFENCE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\ROPE.BMP',  $FF00FF00, SceneryTexture[70]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\ROPE.BMP'), II); SWidth[70]:= II.Width; SHeight[70]:= II.Height;
PropBox.Items.Add('ROPE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\THINROPE.BMP',  $FF00FF00, SceneryTexture[71]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\THINROPE.BMP'), II); SWidth[71]:= II.Width; SHeight[71]:= II.Height;
PropBox.Items.Add('THINROPE.BMP');
  if not xLoadTexture(RootDirectory+'..\SCENERY-GFX\CRATER.BMP',  $FF00FF00, SceneryTexture[72]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\SCENERY-GFX\CRATER.BMP'), II); SWidth[72]:= II.Width; SHeight[72]:= II.Height;
PropBox.Items.Add('CRATER.BMP');

 SceneryElements:= 72;

 for i:= 1 to 128 do
 begin
  Collider[i]:= AddrRec.Collider[i];
 end;

 for i:= MIN_SECTOR to MAX_SECTOR do
  for j:= MIN_SECTOR to MAX_SECTOR do
//    Map.Sectors[i,j]:= AddrRec.Sectors[i,j];
  for k:= 1 to 200 do
  begin
    Map.Sectors[i,j].Polys[k]:= AddrRec.Sectors[i,j].Polys[k];
    Map.Sectors[i,j].PolyCount:= AddrRec.Sectors[i,j].PolyCount;
  end;

//   Map.Path:= AddrRec.Path;
  for k:= 1 to 500 do
  begin
   Map.Path.Waypoint[k].Active:= AddrRec.Path.Waypoint[k].Active;
   Map.Path.Waypoint[k].id:= AddrRec.Path.Waypoint[k].id;
   Map.Path.Waypoint[k].X:= AddrRec.Path.Waypoint[k].X;
   Map.Path.Waypoint[k].Y:= AddrRec.Path.Waypoint[k].Y;
   Map.Path.Waypoint[k].left:= AddrRec.Path.Waypoint[k].left;
   Map.Path.Waypoint[k].right:= AddrRec.Path.Waypoint[k].right;
   Map.Path.Waypoint[k].down:= AddrRec.Path.Waypoint[k].down;
   Map.Path.Waypoint[k].up:= AddrRec.Path.Waypoint[k].up;
   Map.Path.Waypoint[k].m2:= AddrRec.Path.Waypoint[k].m2;
   Map.Path.Waypoint[k].PathNum:= AddrRec.Path.Waypoint[k].PathNum;
   Map.Path.Waypoint[k].ConnectionsNum:= AddrRec.Path.Waypoint[k].ConnectionsNum;
   for i:= 1 to MAX_CONNECTIONS do
    Map.Path.Waypoint[k].Connections[i]:= AddrRec.Path.Waypoint[k].Connections[i];

   Map.Path.WayPoint[i].C1:= 0;
   Map.Path.WayPoint[i].C2:= 0;
   Map.Path.WayPoint[i].C3:= 0;
  end;


  Map.SectorsDivision:= AddrRec.SectorsDivision;


  Map.BackgroundColor:= AddrRec.BackgroundColor;
  Map.BackgroundColor2:= AddrRec.BackgroundColor2;

  Color:= RGB(getBValue(Map.Backgroundcolor),getGValue(Map.Backgroundcolor),getRValue(Map.Backgroundcolor));
  ColorBox4.Selected:= Color;

  Color:= RGB(getBValue(Map.Backgroundcolor2),getGValue(Map.Backgroundcolor2),getRValue(Map.Backgroundcolor2));
  ColorBox5.Selected:= Color;

 Map.LoadTexture(RootDirectory+'..\Textures\'+AddrRec.TextureName);
 TexName:= AddrRec.TextureName;

 with Map do
 begin
   BackPoly[1].Vertices[1]:= GetCustomVertex(NMIN_SECTOR*SectorsDivision,NMIN_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor, 0, 0);
   BackPoly[1].Vertices[2]:= GetCustomVertex(NMAX_SECTOR*SectorsDivision,NMIN_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor, 0, 0);
   BackPoly[1].Vertices[3]:= GetCustomVertex(NMAX_SECTOR*SectorsDivision,NMAX_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor2, 0, 0);
   BackPoly[2].Vertices[1]:= GetCustomVertex(NMAX_SECTOR*SectorsDivision,NMAX_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor2, 0, 0);
   BackPoly[2].Vertices[2]:= GetCustomVertex(NMIN_SECTOR*SectorsDivision,NMAX_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor2, 0, 0);
   BackPoly[2].Vertices[3]:= GetCustomVertex(NMIN_SECTOR*SectorsDivision,NMIN_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor, 0, 0);
 end;

  if not Map.UpdateVertexBuffer then begin hHalt(ERR03); exit; end;

ColorBox4Change(nil); ColorBox5Change(nil);

 MakeUndo;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
 if OpenDialog.Execute then
 begin
   ToolButton3Click(nil);

  if extractfileext(OpenDialog.FileName)='.PMP' then
   LoadFromFile(OpenDialog.FileName);

  if extractfileext(OpenDialog.FileName)='.PMS' then
   LoadFromFile2(OpenDialog.FileName);
 end;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
 if not Compiled then
 if Application.MessageBox('You didn''t click Compile Map before saving. Are you sure to save?','Compile Map warning', MB_OKCANCEL or MB_ICONWARNING)=IDCANCEL then exit;

 if SaveDialog.Execute then
 begin
  if extractfileext(SaveDialog.FileName)='.PMP' then
   SaveToFile(SaveDialog.FileName);

  if extractfileext(SaveDialog.FileName)='.PMS' then
   SaveToFile2(SaveDialog.FileName);
 end;
end;



// -------------------------------------------------------------------
////////    ON MOUSE DOWN          ///////////////////////////////////
// -------------------------------------------------------------------
procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var
   i : integer;
begin
  if (button=mbleft)and(not (ssShift in Shift))and(WaypointsMake) then
  begin
   SelectedWaypoint:= MouseWaypoint;
  end;

  if (button=mbleft)and((ssShift in Shift))and(WaypointsMake) then
   for i:= 1 to MAX_WAYPOINTS do
   if Map.Path.Waypoint[i].Active then
   if (mx>Map.Path.Waypoint[i].X-7)and(mx<Map.Path.Waypoint[i].X+7)and(my>Map.Path.Waypoint[i].Y-7)and(my<Map.Path.Waypoint[i].Y+7) then
   begin
    WaypointMove:= true;
    MouseWaypoint:= i;
    exit;
   end else MouseWaypoint:= 0;


 if Button=mbRight then RClick:= true;
 if (Button=mbLeft)and(ssShift in Shift) then MClick:= True;
 if Button=mbLeft then LClick:= true;

 if (MClick)and(MultiPolNum>0)and(not SpawnCreate)and(not SpawnDelete)and(not PropCreate)and(not ColliderCreate)and(not PropDelete)and(not ColliderDelete)and(not WaypointsMake) then
  MakeUndo;
 if (MClick)and(ColPol>0)and(not SpawnCreate)and(not SpawnDelete)and(not PropCreate)and(not ColliderCreate)and(not PropDelete)and(not ColliderDelete)and(not WaypointsMake) then
  MakeUndo;

end;

procedure TForm1.ToolButton3Click(Sender: TObject);
var i,j : integer;
begin
 Map.VertexBuffer:= NIL;
 if not Map.Initialize then begin hHalt(ERR01); exit; end;

 for i:= 1 to 255 do SpawnPoints[i].Active:= false;
 for i:= 1 to 5000 do Prop[i].Active:= false;
 for i:= 1 to 128 do Collider[i].Active:= false;

 for i:= NMIN_SECTOR to NMAX_SECTOR do
  for j:= NMIN_SECTOR to NMAX_SECTOR do
   Map.Sectors[i,j].PolyCount:= 0;

   for j:= 1 to MAX_WAYPOINTS do
   Map.Path.Waypoint[j].Active:= false;

   for i:= 1 to MAX_WAYPOINTS do
    Map.Path.Waypoint[i].ConnectionsNum:= 0;


 Map.SectorsDivision:= 300;

 ColorBox4.Selected:= clWhite;
 ColorBox5.Selected:= clWhite;

 ColorBox4Change(nil);
 ColorBox5Change(nil);

  JetBox.ItemIndex:= 4;
  PolyBox.ItemIndex:= 0;
  WeatherBox.ItemIndex:= 0;
  StepBox.ItemIndex:= 0;
  SpecialList.ItemIndex:= 0;

  if Zoom>0 then
   ZoomButtonClick(nil);

  Camera.X:= 0; Camera.Y:= 0;
  ColPol:= 0;
  MultiPolNum:= 0;
  OldCX:= 0; OldCY:= 0;
  OldZCX:= 0; OldZCY:= 0;
  

 Map.UpdateVertexBuffer;
 UpdateSelPolys;
  

//  MakeUndo;
end;

procedure TForm1.ToolButton6Click(Sender: TObject);
var i,j : integer;
begin
if UndoRound<0 then exit;

 Map.VertexBuffer:= NIL;
 if not Map.Initialize then begin hHalt(ERR01); exit; end;

 for i:= 1 to 255 do SpawnPoints[i].Active:= false;
 for i:= 1 to 5000 do Prop[i].Active:= false;
 for i:= 1 to 128 do Collider[i].Active:= false;

 for i:= NMIN_SECTOR to NMAX_SECTOR do
  for j:= NMIN_SECTOR to NMAX_SECTOR do
   Map.Sectors[i,j].PolyCount:= 0;

   for j:= 1 to MAX_WAYPOINTS do
   Map.Path.Waypoint[j].Active:= false;

   for i:= 1 to MAX_WAYPOINTS do
    Map.Path.Waypoint[i].ConnectionsNum:= 0;


  JetBox.ItemIndex:= 4;
  PolyBox.ItemIndex:= 0;
  WeatherBox.ItemIndex:= 0;
  StepBox.ItemIndex:= 0;
  SpecialList.ItemIndex:= 0;

  ColPol:= 0;
  MultiPolNum:= 0;

 LoadFromFile2(ExtractFilePath(ParamStr(0))+'\Temp\'+'_undo'{+inttostr(UndoRound)}+'.pms');
end;

procedure TForm1.ToolButton7Click(Sender: TObject);
begin
 if OpenDialog2.Execute then
 begin
  Map.Texture:= NIL;
  Map.LoadTexture(OpenDialog2.Filename);
  TexName:= extractfilename(OpenDialog2.Filename);
 end;
end;

function TForm1.CreateSpawnPoint(sX,sY,sTeam : integer):integer;
var
 i : integer;
begin
 for i:= 1 to 255+1 do
 begin
  if i=255+1 then
  begin
   result:= -1;
   exit;
  end;
  if not SpawnPoints[i].Active then break;
 end;
 {i is now the active spawn point}

 SpawnPoints[i].Active:= true;
 SpawnPoints[i].X:= sX;
 SpawnPoints[i].Y:= sY;
 SpawnPoints[i].Team:= sTeam;

 {activate sprite}
  result:= i;
end;


function TForm1.CreateProp(sX,sY,Style : integer):integer;
var
 i : integer;
 Temp : Integer;
 Temp2: String;
begin
 for i:= 1 to 5000+1 do
 begin
  if i=5000+1 then
  begin
   result:= -1;
   exit;
  end;
  if not Prop[i].Active then break;
 end;
 {i is now the active spawn point}

 Prop[i].Active:= true;
 Prop[i].X:= sX;
 Prop[i].Y:= sY;
 Prop[i].Style:= Style;

 Prop[i].Width:= SWidth[Prop[i].Style];
 Prop[i].Height:= SHeight[Prop[i].Style];


 Prop[i].Alpha:= 255;
 Prop[i].ScaleX:= 1;
 Prop[i].ScaleY:= 1;

 if Level1.Checked then
  Prop[i].Level:= 0;
 if Level2.Checked then
  Prop[i].Level:= 1;
 if Level3.Checked then
  Prop[i].Level:= 2;

 Temp:= ColorToRGB(ColorBox6.Selected);
 Temp2 := IntToHex(temp,6);
 Prop[i].Color:= strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2));


 {activate sprite}
  result:= i;
end;


function TForm1.CreateCollider(sX,sY, Radius : integer):integer;
var
 i : integer;
begin
 for i:= 1 to 128+1 do
 begin
  if i=128+1 then
  begin
   result:= -1;
   exit;
  end;
  if not Collider[i].Active then break;
 end;
 {i is now the active spawn point}

 Collider[i].Active:= true;
 Collider[i].X:= sX;
 Collider[i].Y:= sY;
 Collider[i].Radius:= Radius;



 {activate sprite}
  result:= i;
end;


procedure TForm1.All1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 0;
end;

procedure TForm1.Team1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 1;
end;

procedure TForm1.Team2Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 2;
end;

procedure TForm1.SPB1Click(Sender: TObject);
begin
 SpawnCreate:= true;
end;

procedure TForm1.Undo1Click(Sender: TObject);
begin
 SpawnPoints[LastSpawnPoint].Active:= false;
 LastSpawnPoint:= LastSpawnPoint-1;
 if LastSpawnPoint=0 then LastSpawnPoint:= 255;
end;

procedure TForm1.ToolButton9Click(Sender: TObject);
begin
 if WireFrame then WireFrame:= false else WireFrame:= true;

 if WireFrame then
    D3DDEV8.SetRenderState(D3DRS_FILLMODE, D3DFILL_WIREFRAME) else
    D3DDEV8.SetRenderState(D3DRS_FILLMODE, D3DFILL_SOLID);
end;

procedure TForm1.Delete1Click(Sender: TObject);
begin
 SpawnDelete:= true;
end;

// -------------------------------------------------------------------
////////    GENERATE SECTORS      ///////////////////////////////////
// -------------------------------------------------------------------
procedure TForm1.SectorsClick(Sender: TObject);
var i, j : integer;
 k, h : integer;
 x, y : integer;
 p, q : integer;
 no : boolean;
 Farest : single;
 Xl, Xr, Yn, Ys : single;
 HalfLengthX, HalfLengthY : single;
 Progress : single;
begin

 FindFarestEdges(Xl, Xr, Ys, Yn);

 { I -  przesuniecie aby krawedzie lewa i gora byla przy 0}
 for i:= 1 to Map.PolyCount do
 begin
    {fix perps}
     CalcPerps(i);

  Map.Polys[i].Vertices[1].X:= Map.Polys[i].Vertices[1].X + abs(Xl);
  Map.Polys[i].Vertices[2].X:= Map.Polys[i].Vertices[2].X + abs(Xl);
  Map.Polys[i].Vertices[3].X:= Map.Polys[i].Vertices[3].X + abs(Xl);
  Map.Polys[i].Vertices[1].Y:= Map.Polys[i].Vertices[1].Y + abs(Yn);
  Map.Polys[i].Vertices[2].Y:= Map.Polys[i].Vertices[2].Y + abs(Yn);
  Map.Polys[i].Vertices[3].Y:= Map.Polys[i].Vertices[3].Y + abs(Yn);
 end;
 for i:= 1 to 255 do
 if Spawnpoints[i].Active then
 begin
  Spawnpoints[i].X:= round(Spawnpoints[i].X + abs(Xl));
  Spawnpoints[i].Y:= round(Spawnpoints[i].Y + abs(Yn));
 end;
 for i:= 1 to 255 do
 if Prop[i].Active then
 begin
  Prop[i].X:= round(Prop[i].X + abs(Xl));
  Prop[i].Y:= round(Prop[i].Y + abs(Yn));
 end;
 for i:= 1 to 128 do
 if Collider[i].Active then
 begin
  Collider[i].X:= round(Collider[i].X + abs(Xl));
  Collider[i].Y:= round(Collider[i].Y + abs(Yn));
 end;
 for i:= 1 to MAX_WAYPOINTS do
 if Map.Path.Waypoint[i].Active then
 begin
  Map.Path.Waypoint[i].X:= round(Map.Path.Waypoint[i].X + abs(Xl));
  Map.Path.Waypoint[i].Y:= round(Map.Path.Waypoint[i].Y + abs(Yn));
 end;
 Camera.X:= round(Camera.X + abs(Xl));
 Camera.Y:= round(Camera.Y + abs(Yn));

 { II -  przesuniecie na srodek}
   HalfLengthX:= (abs(Xl)+abs(Xr))/2;
   HalfLengthY:= (abs(Ys)+abs(Yn))/2;

 for i:= 1 to Map.PolyCount do
 begin
  Map.Polys[i].Vertices[1].X:= Map.Polys[i].Vertices[1].X - HalfLengthX;
  Map.Polys[i].Vertices[2].X:= Map.Polys[i].Vertices[2].X - HalfLengthX;
  Map.Polys[i].Vertices[3].X:= Map.Polys[i].Vertices[3].X - HalfLengthX;
  Map.Polys[i].Vertices[1].Y:= Map.Polys[i].Vertices[1].Y - HalfLengthY;
  Map.Polys[i].Vertices[2].Y:= Map.Polys[i].Vertices[2].Y - HalfLengthY;
  Map.Polys[i].Vertices[3].Y:= Map.Polys[i].Vertices[3].Y - HalfLengthY;
 end;
 for i:= 1 to 255 do
 if Spawnpoints[i].Active then
 begin
  Spawnpoints[i].X:= round(Spawnpoints[i].X - HalfLengthX);
  Spawnpoints[i].Y:= round(Spawnpoints[i].Y - HalfLengthY);
 end;
 for i:= 1 to 5000 do
 if Prop[i].Active then
 begin
  Prop[i].X:= round(Prop[i].X - HalfLengthX);
  Prop[i].Y:= round(Prop[i].Y - HalfLengthY);
 end;
 for i:= 1 to 128 do
 if Collider[i].Active then
 begin
  Collider[i].X:= round(Collider[i].X - HalfLengthX);
  Collider[i].Y:= round(Collider[i].Y - HalfLengthY);
 end;
 Camera.X:= round(Camera.X - HalfLengthX);
 Camera.Y:= round(Camera.Y - HalfLengthY);
 for i:= 1 to MAX_WAYPOINTS do
 if Map.Path.Waypoint[i].Active then
 begin
  Map.Path.Waypoint[i].X:= round(Map.Path.Waypoint[i].X - HalfLengthX);
  Map.Path.Waypoint[i].Y:= round(Map.Path.Waypoint[i].Y - HalfLengthY);
 end;

 {III}
  Farest:= FindFarest;
  Map.SectorsDivision:= round((Farest+100) / NMAX_SECTOR);

 {xxxxx}
 for i:= NMIN_SECTOR to NMAX_SECTOR do
  for j:= NMIN_SECTOR to NMAX_SECTOR do
  begin
   Map.Sectors[i,j].PolyCount:= 0;
   for k:= 1 to MaxPolys do
    Map.Sectors[i,j].Polys[k]:= 0;
  end;

   for k:= NMIN_SECTOR*Map.SectorsDivision to NMAX_SECTOR*Map.SectorsDivision do
   if k mod SKIPCHECK = 0 then
    for h:= NMIN_SECTOR*Map.SectorsDivision to NMAX_SECTOR*Map.SectorsDivision do
    if h mod SKIPCHECK = 0 then
    begin

     Progress:= ((k+NMAX_SECTOR*Map.SectorsDivision)/(2*25*Map.SectorsDivision))*100;
//     Form1.Caption:= 'Progress...'+inttostr((k+NMAX_SECTOR*Map.SectorsDivision))+'/'+inttostr(SECTOR_NUM*Map.SectorsDivision);
     Form1.Caption:= 'Progress... '+inttostr(round(Progress))+'%';
     Application.ProcessMessages;

      for p:= 1 to Map.PolyCount do
      begin

      if Map.PointInPoly(k, h, p) then
      begin

       no:= false;
       for q:= 1 to Map.Sectors[round(k/Map.SectorsDivision),round(h/Map.SectorsDivision)].PolyCount do
       if Map.Sectors[round(k/Map.SectorsDivision),round(h/Map.SectorsDivision)].Polys[q]=p then no:= true;

        if not no then
        begin
         inc(Map.Sectors[round(k/Map.SectorsDivision),round(h/Map.SectorsDivision)].PolyCount);
         Map.Sectors[round(k/Map.SectorsDivision),round(h/Map.SectorsDivision)].Polys[Map.Sectors[round(k/Map.SectorsDivision),round(h/Map.SectorsDivision)].PolyCount]:= p;
        end;

      end;
      end;


  end;

   Compiled:= true;

 ColorBox4Change(nil);
 ColorBox5Change(nil);


end;

procedure TForm1.Division1Click(Sender: TObject);
var s : string;
begin
 inputquery('Sectors', 'Define Sectors division:', s);
 Map.SectorsDivision:= strtoint(s);
end;

procedure TForm1.ColorBox4Change(Sender: TObject);
var
 Temp : integer;
 Temp2 : string;
begin
  Temp:= ColorToRGB(form1.ColorBox4.Selected);
  Temp2 := IntToHex(temp,6);
  Map.BackgroundColor:= strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2));

 with Map do
 begin
   BackPoly[1].Vertices[1]:= GetCustomVertex(NMIN_SECTOR*SectorsDivision,NMIN_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor, 0, 0);
   BackPoly[1].Vertices[2]:= GetCustomVertex(NMAX_SECTOR*SectorsDivision,NMIN_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor, 0, 0);
   BackPoly[1].Vertices[3]:= GetCustomVertex(NMAX_SECTOR*SectorsDivision,NMAX_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor2, 0, 0);
   BackPoly[2].Vertices[1]:= GetCustomVertex(NMAX_SECTOR*SectorsDivision,NMAX_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor2, 0, 0);
   BackPoly[2].Vertices[2]:= GetCustomVertex(NMIN_SECTOR*SectorsDivision,NMAX_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor2, 0, 0);
   BackPoly[2].Vertices[3]:= GetCustomVertex(NMIN_SECTOR*SectorsDivision,NMIN_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor, 0, 0);
   UpdateVertexBuffer;
 end;

end;

procedure TForm1.PropsClick(Sender: TObject);
begin
 PropCreate:= true;
 PropState:= 0;
end;

procedure TForm1.Make1Click(Sender: TObject);
var
 II : TD3DXImageInfo;
 i : integer;
begin
 if (PropBox.ItemIndex>0)and(PropBox.ItemIndex<SceneryElements+1) then
 PropStyle:= PropBox.ItemIndex else
 begin
   if (SceneryFiles.ItemIndex<0)or(SceneryFiles.ItemIndex>SceneryFiles.Items.Count-1) then exit;

   for i:= 0 to PropBox.Items.Count-1 do
    if PropBox.Items.Strings[i]=SceneryFiles.Items.Strings[SceneryFiles.ItemIndex] then
    begin
     PropCreate:= true;
     PropState:= 0;
     PropStyle:= i;
     PropBox.ItemIndex:= i;
     exit;
    end;

   AddCustomScenery(SceneryFiles.Items.Strings[SceneryFiles.ItemIndex]);
   PropBox.ItemIndex:= PropBox.Items.Count-1;
   PropStyle:= PropBox.ItemIndex;
 end;

 PropCreate:= true;
 PropState:= 0;
end;

procedure TForm1.Delete2Click(Sender: TObject);
begin
 PropDelete:= true;
end;

procedure TForm1.Delete2CClick(Sender: TObject);
begin
 ColliderDelete:= true;
end;


procedure TForm1.Style1Click(Sender: TObject);
var
 s : string;
begin
 inputquery('Prop', 'Type in style number 1..n', s);
 PropStyle:= strtoint(s);
end;

procedure TForm1.Undo2Click(Sender: TObject);
begin
 Prop[PropNum].Active:= false;
end;


function TForm1.FindFarest:single;
var
 i : integer;
begin
Result:= 0;
 for i:= 1 to MaxPolys2 do
 begin
  if abs(Map.Polys[i].Vertices[1].X)>Result then Result:= abs(Map.Polys[i].Vertices[1].X);
  if abs(Map.Polys[i].Vertices[1].Y)>Result then Result:= abs(Map.Polys[i].Vertices[1].Y);
  if abs(Map.Polys[i].Vertices[2].X)>Result then Result:= abs(Map.Polys[i].Vertices[2].X);
  if abs(Map.Polys[i].Vertices[2].Y)>Result then Result:= abs(Map.Polys[i].Vertices[2].Y);
  if abs(Map.Polys[i].Vertices[3].X)>Result then Result:= abs(Map.Polys[i].Vertices[3].X);
  if abs(Map.Polys[i].Vertices[3].Y)>Result then Result:= abs(Map.Polys[i].Vertices[3].Y);
 end;
end;

procedure TForm1.FindFarestEdges(var Xl, Xr, Yn, Ys : single);
var
 i : integer;
begin
Xl:= 100000000000;
Xr:= -100000000000;
Yn:= -100000000000;
Ys:= 100000000000;
 for i:= 1 to Map.PolyCount do
 begin
  if Map.Polys[i].Vertices[1].X>Xr then Xr:= Map.Polys[i].Vertices[1].X;
  if Map.Polys[i].Vertices[2].X>Xr then Xr:= Map.Polys[i].Vertices[2].X;
  if Map.Polys[i].Vertices[3].X>Xr then Xr:= Map.Polys[i].Vertices[3].X;
  if Map.Polys[i].Vertices[1].X<Xl then Xl:= Map.Polys[i].Vertices[1].X;
  if Map.Polys[i].Vertices[2].X<Xl then Xl:= Map.Polys[i].Vertices[2].X;
  if Map.Polys[i].Vertices[3].X<Xl then Xl:= Map.Polys[i].Vertices[3].X;
  if Map.Polys[i].Vertices[1].Y>Yn then Yn:= Map.Polys[i].Vertices[1].Y;
  if Map.Polys[i].Vertices[2].Y>Yn then Yn:= Map.Polys[i].Vertices[2].Y;
  if Map.Polys[i].Vertices[3].Y>Yn then Yn:= Map.Polys[i].Vertices[3].Y;
  if Map.Polys[i].Vertices[1].Y<Ys then Ys:= Map.Polys[i].Vertices[1].Y;
  if Map.Polys[i].Vertices[2].Y<Ys then Ys:= Map.Polys[i].Vertices[2].Y;
  if Map.Polys[i].Vertices[3].Y<Ys then Ys:= Map.Polys[i].Vertices[3].Y;
 end;
end;

procedure TForm1.ColorBox5Change(Sender: TObject);
var
 Temp : integer;
 Temp2 : string;
begin
  Temp:= ColorToRGB(form1.ColorBox5.Selected);
  Temp2 := IntToHex(temp,6);
  Map.BackgroundColor2:= strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2));

 with Map do
 begin
   BackPoly[1].Vertices[1]:= GetCustomVertex(NMIN_SECTOR*SectorsDivision,NMIN_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor, 0, 0);
   BackPoly[1].Vertices[2]:= GetCustomVertex(NMAX_SECTOR*SectorsDivision,NMIN_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor, 0, 0);
   BackPoly[1].Vertices[3]:= GetCustomVertex(NMAX_SECTOR*SectorsDivision,NMAX_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor2, 0, 0);
   BackPoly[2].Vertices[1]:= GetCustomVertex(NMAX_SECTOR*SectorsDivision,NMAX_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor2, 0, 0);
   BackPoly[2].Vertices[2]:= GetCustomVertex(NMIN_SECTOR*SectorsDivision,NMAX_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor2, 0, 0);
   BackPoly[2].Vertices[3]:= GetCustomVertex(NMIN_SECTOR*SectorsDivision,NMIN_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor, 0, 0);
   UpdateVertexBuffer;
 end;  
  
end;

procedure TForm1.SpawnButtonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
 m : tpoint;
begin
 GetCursorPos(m);
 SpawnButton.PopupMenu.Popup(m.x, m.y);
end;

function TForm1.CreateWayPoint(sX,sY : integer):integer;
var
 i : integer;
begin
 for i:= 1 to MAX_WAYPOINTS+1 do
 begin
  if i=MAX_WAYPOINTS+1 then
  begin
   result:= -1;
   exit;
  end;
  if not Map.Path.Waypoint[i].Active then break;
 end;
 {i is now the active waypoint}

 Map.Path.Waypoint[i].left:= false;
 Map.Path.Waypoint[i].right:= false;
 Map.Path.Waypoint[i].up:= false;
 Map.Path.Waypoint[i].down:= false;
 Map.Path.Waypoint[i].m2:= false;
 Map.Path.Waypoint[i].C1:= 0;
 Map.Path.Waypoint[i].C2:= 0;
 Map.Path.Waypoint[i].C3:= 0;
 Map.Path.Waypoint[i].Active:= true;
 Map.Path.Waypoint[i].X:= sX;
 Map.Path.Waypoint[i].Y:= sY;
 Map.Path.Waypoint[i].id:= i;
 Map.Path.Waypoint[i].ConnectionsNum:= 0;

 {activate waypoint}
  result:= i;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var i, j, k : integer;
begin
  Map.Path.Waypoint[MouseWaypoint].Active:= false;
  for k:= 1 to MAX_CONNECTIONS do
  Map.Path.Waypoint[MouseWaypoint].Connections[k]:= 0;
   Map.Path.Waypoint[MouseWaypoint].ConnectionsNum:= 0;

  for j:= 1 to MAX_WAYPOINTS do
  if Map.Path.Waypoint[j].Active then
  for k:= 1 to MAX_CONNECTIONS do
  if Map.Path.Waypoint[j].Connections[k]= MouseWaypoint then
  begin
   Map.Path.Waypoint[j].Connections[k]:= Map.Path.Waypoint[j].Connections[Map.Path.Waypoint[j].ConnectionsNum];
   Map.Path.Waypoint[j].Connections[Map.Path.Waypoint[j].ConnectionsNum]:= 0;
   dec(Map.Path.Waypoint[j].ConnectionsNum);
  end;
end;



procedure TForm1.SpeedButton4Click(Sender: TObject);
var i : integer;
begin
 for i:= 1 to MAX_WAYPOINTS do
 begin
  Map.Path.Waypoint[i].Active:= false;
  Map.Path.Waypoint[i].ConnectionsNum:= 0;
 end;
end;

procedure TForm1.leftcClick(Sender: TObject);
begin
 if MouseWaypoint>0 then
 Map.Path.WayPoint[MouseWayPoint].Left:= LeftC.Checked;
end;

procedure TForm1.rightcClick(Sender: TObject);
begin
 if MouseWaypoint>0 then
 Map.Path.WayPoint[MouseWayPoint].Right:= RightC.Checked;
end;

procedure TForm1.upcClick(Sender: TObject);
begin
 if MouseWaypoint>0 then
 Map.Path.WayPoint[MouseWayPoint].Up:= UpC.Checked;
end;

procedure TForm1.downcClick(Sender: TObject);
begin
 if MouseWaypoint>0 then
 Map.Path.WayPoint[MouseWayPoint].Down:= DownC.Checked;
end;

procedure TForm1.flycClick(Sender: TObject);
begin
 if MouseWaypoint>0 then
 Map.Path.WayPoint[MouseWayPoint].M2:= FlyC.Checked;
end;

procedure TForm1.Path1Click(Sender: TObject);
begin
 if Path1.Checked then
 if MouseWaypoint>0 then
 Map.Path.WayPoint[MouseWayPoint].PathNum:= 1;

 if Path2.Checked then
 if MouseWaypoint>0 then
 Map.Path.WayPoint[MouseWayPoint].PathNum:= 2;
end;

procedure TForm1.path2Click(Sender: TObject);
begin
 if Path1.Checked then
 if MouseWaypoint>0 then
 Map.Path.WayPoint[MouseWayPoint].PathNum:= 1;

 if Path2.Checked then
 if MouseWaypoint>0 then
 Map.Path.WayPoint[MouseWayPoint].PathNum:= 2;
end;

procedure TForm1.VerySmall1Click(Sender: TObject);
begin
 ColliderRadius:= 12;
 ColliderCreate:= true;
end;

procedure TForm1.Small1Click(Sender: TObject);
begin
 ColliderRadius:= 16;
 ColliderCreate:= true;
end;


procedure TForm1.Medium1Click(Sender: TObject);
begin
 ColliderRadius:= 24;
 ColliderCreate:= true;
end;


procedure TForm1.Big1Click(Sender: TObject);
begin
 ColliderRadius:= 32;
 ColliderCreate:= true;
end;


procedure TForm1.ColliderButtonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
 m : tpoint;
begin
 GetCursorPos(m);
 ColliderButton.PopupMenu.Popup(m.x, m.y);
end;

procedure TForm1.GridButtonMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
 m : tpoint;
begin
 GetCursorPos(m);
 GridButton.PopupMenu.Popup(m.x, m.y);
end;

procedure TForm1.Off1Click(Sender: TObject);
begin
 Grid:= false;
end;

procedure TForm1.On11Click(Sender: TObject);
begin
 Grid:= true;
 GridScale:= 4;
end;

procedure TForm1.On21Click(Sender: TObject);
begin
 Grid:= true;
 GridScale:= 6;
end;

procedure TForm1.ON31Click(Sender: TObject);
begin
 Grid:= true;
 GridScale:= 8;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
if ColPol>0 then
begin
 Map.Polys[ColPol].Vertices[1]:= GetCustomVertex(round(UndoPoly.Vertices[1].X), round(UndoPoly.Vertices[1].Y), 1, 1, 0.0, 0.0, UndoPoly.Vertices[1].DColor, Camera.X, Camera.Y);
 Map.Polys[ColPol].Vertices[2]:= GetCustomVertex(round(UndoPoly.Vertices[2].X), round(UndoPoly.Vertices[2].Y), 1, 1, 0.0, 0.0, UndoPoly.Vertices[2].DColor, Camera.X, Camera.Y);
 Map.Polys[ColPol].Vertices[3]:= GetCustomVertex(round(UndoPoly.Vertices[3].X), round(UndoPoly.Vertices[3].Y), 1, 1, 0.0, 0.0, UndoPoly.Vertices[3].DColor, Camera.X, Camera.Y);
 Map.Perp[ColPol][1]:= UndoPerp[1];
 Map.Perp[ColPol][2]:= UndoPerp[2];
 Map.Perp[ColPol][3]:= UndoPerp[3];

 dec(Map.PolyCount);
 ColPol:= 0;

 Map.UpdateVertexBuffer;
end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
 Temp : Integer;
 Temp2: String;
begin
if ColPol>0 then
begin
//  MakeUndo;

  Temp:= ColorToRGB(ColorBox1.Selected);
  Temp2 := IntToHex(temp,6);
  Map.Polys[ColPol].Vertices[1].DColor:= strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2));
  Map.Polys[ColPol].Vertices[1]:= GetCustomVertex(Map.Polys[ColPol].Vertices[1].X, Map.Polys[ColPol].Vertices[1].Y, 1, 1, Map.Polys[ColPol].Vertices[1].tu, Map.Polys[ColPol].Vertices[1].tv, Map.Polys[ColPol].Vertices[1].DColor, Camera.X, Camera.Y);

  Temp:= ColorToRGB(ColorBox2.Selected);
  Temp2 := IntToHex(temp,6);
  Map.Polys[ColPol].Vertices[2].DColor:= strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2));
  Map.Polys[ColPol].Vertices[2]:= GetCustomVertex(Map.Polys[ColPol].Vertices[2].X, Map.Polys[ColPol].Vertices[2].Y, 1, 1, Map.Polys[ColPol].Vertices[2].tu, Map.Polys[ColPol].Vertices[2].tv, Map.Polys[ColPol].Vertices[2].DColor, Camera.X, Camera.Y);

  Temp:= ColorToRGB(ColorBox3.Selected);
  Temp2 := IntToHex(temp,6);
  Map.Polys[ColPol].Vertices[3].DColor:= strtoint('$FF'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2));
  Map.Polys[ColPol].Vertices[3]:= GetCustomVertex(Map.Polys[ColPol].Vertices[3].X, Map.Polys[ColPol].Vertices[3].Y, 1, 1, Map.Polys[ColPol].Vertices[3].tu, Map.Polys[ColPol].Vertices[3].tv, Map.Polys[ColPol].Vertices[3].DColor, Camera.X, Camera.Y);

  Map.UpdateVertexBuffer;
end;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
 Color : longint;
begin
   {change colors in box}
   ColorBox1.Selected:= ColorBox1.NoneColorColor;
   ColorBox2.Selected:= ColorBox2.NoneColorColor;
   ColorBox3.Selected:= ColorBox3.NoneColorColor;
   Color:= RGB(getBValue(Map.Polys[ColPol].Vertices[1].DColor),getGValue(Map.Polys[ColPol].Vertices[1].DColor),getRValue(Map.Polys[ColPol].Vertices[1].DColor));
   ColorBox1.Selected:= Color;
   Color:= RGB(getBValue(Map.Polys[ColPol].Vertices[2].DColor),getGValue(Map.Polys[ColPol].Vertices[2].DColor),getRValue(Map.Polys[ColPol].Vertices[2].DColor));
   ColorBox2.Selected:= Color;
   Color:= RGB(getBValue(Map.Polys[ColPol].Vertices[3].DColor),getGValue(Map.Polys[ColPol].Vertices[3].DColor),getRValue(Map.Polys[ColPol].Vertices[3].DColor));
   ColorBox3.Selected:= Color;
end;


procedure TForm1.UpdateSelPolys;
var
 i : integer;
 _ptr : pByte;
begin
 SelPolyCount:= MultiPolNum;

 if SelPolyCount>0 then
 for i:= 1 to MultiPolNum do
 begin
  SelPoly[i]:= Map.Polys[MultiPol[i]];
  SelPoly[i].Vertices[1].DColor:= clWhite;
  SelPoly[i].Vertices[2].DColor:= clWhite;
  SelPoly[i].Vertices[3].DColor:= clWhite;
 end;

  // Lock, fill and unlock vertex buffer.
  if failed(SelVertexBuffer.Lock(0, SizeOf(SelPoly), _ptr, 0)) then exit;
  Move(SelPoly, _ptr^, SizeOf(SelPoly));
  SelVertexBuffer.Unlock;
end;

procedure TForm1.ScrollSelPolys(CX, CY: single);
var
 _ptr : PCV;
 i, j : integer;
begin
 if failed(SelVertexBuffer.Lock(0, SizeOf(SelPoly), pByte(_ptr), 0)) then exit;

 for i:= 1 to SelPolyCount do
 begin
  with SelPoly[i] do
  for j:= 1 to 3 do
  begin
   _ptr[i][j].X:= 320+Vertices[j].X-CX;
   _ptr[i][j].Y:= 240+Vertices[j].Y-CY;
  end; {with Polys / for j}
 end; {for i}

  SelVertexBuffer.Unlock;
end;

procedure TForm1.ScaleSelPolys(SX, SY, CX, CY: single);
var
 _ptr : PCV;
 i, j : integer;
begin
 if failed(SelVertexBuffer.Lock(0, SizeOf(SelPoly), pByte(_ptr), 0)) then exit;

 for i:= 1 to SelPolyCount do
 begin
  with SelPoly[i] do
  for j:= 1 to 3 do
  begin
   _ptr[i][j].X:= SX*Vertices[j].X-CX;
   _ptr[i][j].Y:= SY*Vertices[j].Y-CY;
  end; {with Polys / for j}
 end; {for i}

  SelVertexBuffer.Unlock;
end;



procedure TForm1.CalcPerps(i : integer);
var
 T : TCustomVertex;
 V, V1, V2 : TD3DXVector3;
 _v0, _v1, _v2, U : TD3DXVector3;
 _edge1, _edge2, _edge3 : TD3DXVector3;
begin
           if (((Map.Polys[i].Vertices[2].X - Map.Polys[i].Vertices[1].X) * (Map.Polys[i].Vertices[3].Y - Map.Polys[i].Vertices[2].Y))
        - ((Map.Polys[i].Vertices[2].Y - Map.Polys[i].Vertices[1].Y) * (Map.Polys[i].Vertices[3].X - Map.Polys[i].Vertices[2].X)))<0 then
            begin
             T:= Map.Polys[i].Vertices[2];
             Map.Polys[i].Vertices[2]:= Map.Polys[i].Vertices[1];
             Map.Polys[i].Vertices[1]:= T;
            end;
            //////// CALC PERPENDICULARS //////
          _v0.x:= Map.Polys[i].Vertices[1].X; _v0.y:=Map.Polys[i].Vertices[1].Y;
          _v1.x:= Map.Polys[i].Vertices[2].X; _v1.y:= Map.Polys[i].Vertices[2].Y;
          _v2.x:= Map.Polys[i].Vertices[3].X; _v2.y:= Map.Polys[i].Vertices[3].Y;
          _edge1.x := _v1.x - _v0.x;  _edge1.y := _v1.y - _v0.y;
          Map.Perp[i][1].X:= -_edge1.Y;  Map.Perp[i][1].Y:= _edge1.X;
          D3DXVec3Normalize(Map.Perp[i][1],Map.Perp[i][1]);
          Map.Perp[i][2]:= Map.Perp[i][1];
          Map.Perp[i][3]:= Map.Perp[i][1];
          _edge2.x := _v2.x - _v1.x;  _edge2.y := _v2.y - _v1.y;
          Map.Perp[i][2].X:= -_edge2.Y;  Map.Perp[i][2].Y:= _edge2.X;
          D3DXVec3Normalize(Map.Perp[i][2],Map.Perp[i][2]);
          _edge3.x := _v0.x - _v2.x;  _edge3.y := _v0.y - _v2.y;
          Map.Perp[i][3].X:= -_edge3.Y;  Map.Perp[i][3].Y:= _edge3.X;
          D3DXVec3Normalize(Map.Perp[i][3],Map.Perp[i][3]);
end;




// -------------------------------------------------------------------
////////    MAP SAVING             ///////////////////////////////////
// -------------------------------------------------------------------
procedure TForm1.SaveToFile2(filename : string);
var
 F : file;
 i, j : integer;
 x, y : integer;
 s : string;
 Header :  TMapFile_Header;
 Options :  TMapFile_Options;
 Polygon_Start : TMapFile_Polygon_Start;
 Polygon : TMapFile_Polygon;
 Sector_Start : TMapFile_Sector_Start;
 Sector_New : TMapFile_Sector_New;
 Sector_PolyNum : TMapFile_Sector_PolyNum;
 Prop_Start : TMapFile_Prop_Start;
 Prop_New : TMapFile_Prop;
 Scenery_Start : TMapFile_Scenery_Start;
 Scenery_New : TMapFile_Scenery;
 Collider_Start : TMapFile_Collider_Start;
 Collider_New : TMapFile_Collider;
 SpawnPoint_Start : TMapFile_SpawnPoint_Start;
 SpawnPoint_New : TMapFile_SpawnPoint;
 WayPoint_Start : TMapFile_WayPoint_Start;
 WayPoint_New : TMapFile_WayPoint;
 b : integer;
begin
 AssignFile(F, filename);
 Rewrite(F, 1);

 {save header}
 Header.Version:= SHORTVER;

 BlockWrite(F, Header, sizeof(Header));


 {save options}
 Options.MapName:= MapName.Text;
 Options.TextureName:= TexName;
 Options.BackgroundColor:= Map.BackgroundColor;
 Options.BackgroundColor2:= Map.BackgroundColor2;
 Options.StartJet:= JetBar.Position;
 case JetBox.ItemIndex of
  0 : Options.StartJet:= 0;
  1 : Options.StartJet:= 12;
  2 : Options.StartJet:= 45;
  3 : Options.StartJet:= 95;
  4 : Options.StartJet:= 190;
  5 : Options.StartJet:= 320;
  6 : Options.StartJet:= 800;
 end;
 JetBar.Position:= Options.StartJet;
 randomize;
 Options.MapRandomID:= random(1000000);

 Options.GrenadePacks:= strtoint(GrenadeBox.Text);
 Options.Medikits:= strtoint(MedicBox.Text);
 Options.Weather:= WeatherBox.ItemIndex;
 Options.Steps:= StepBox.ItemIndex;

 BlockWrite(F, Options, sizeof(Options));


 {save polygon start}
 Polygon_Start.PolyCount:= Map.PolyCount;

 BlockWrite(F, Polygon_Start, sizeof(Polygon_Start));


 {save polygons}
 for i:= 1 to Map.PolyCount do
 begin
  Polygon.Poly:= Map.Polys[i];
  for j:= 1 to 3 do
   Polygon.Perp[j]:= Map.Perp[i][j];

  Polygon.PolyType:= Map.PolyType[i];

  BlockWrite(F, Polygon, sizeof(Polygon));
 end;


 {save sectors start}
 Sector_Start.SectorsDivision:= Map.SectorsDivision;

 SECTOR_NUM:= 25;

 Sector_Start.SectorNum:= SECTOR_NUM;

 BlockWrite(F, Sector_Start, sizeof(Sector_Start));

 b:= 0;

 {save sectors}
 for x:= -SECTOR_NUM to SECTOR_NUM do
  for y:= -SECTOR_NUM to SECTOR_NUM do
  begin
   {save new sector}
   Sector_New.PolyCount:= Map.Sectors[x, y].PolyCount;

   BlockWrite(F, Sector_New, sizeof(Sector_New));

    {save sectors polygon nums}
     for j:= 1 to Sector_New.PolyCount do
     begin
      Sector_PolyNum.Polys:= Map.Sectors[x, y].Polys[j];

      BlockWrite(F, Sector_PolyNum, sizeof(Sector_PolyNum));
     end;

    inc(b);
  end;


 {save prop start}
 j:= 0;
 for i:= 1 to high(Prop) do
 if Prop[i].Active then
  inc(j);

 Prop_Start.Num:= j;

 BlockWrite(F, Prop_Start, sizeof(Prop_Start));


 {save prop}
 for i:= 1 to high(Prop) do
 if Prop[i].Active then
 begin
  Prop_New.Prop:= Prop[i];

  BlockWrite(F, Prop_New, sizeof(Prop_New));
 end;


 {save scenery start}
 Scenery_Start.Num:= SceneryElements;

 BlockWrite(F, Scenery_Start, sizeof(Scenery_Start));


 {save scenery new}
 for i:= 1 to SceneryElements do
 begin
  Scenery_New.Name:= PropBox.Items.Strings[i];
  Scenery_New.Date:= CheckFileDate(RootDirectory+'..\Scenery-gfx\'+PropBox.Items.Strings[i]);

  BlockWrite(F, Scenery_New, sizeof(Scenery_New));
 end;


 {save collider start}
 j:= 0;
 for i:= 1 to high(Collider) do
 if Collider[i].Active then
  inc(j);

 Collider_Start.Num:= j;

 BlockWrite(F, Collider_Start, sizeof(Collider_Start));


 {save collider}
 for i:= 1 to high(Collider) do
 if Collider[i].Active then
 begin
  Collider_New.Collider:= Collider[i];

  BlockWrite(F, Collider_New, sizeof(Collider_New));
 end;


 {save spawnpoint start}
 j:= 0;
 for i:= 1 to high(SpawnPoints) do
 if SpawnPoints[i].Active then
  inc(j);

 SpawnPoint_Start.Num:= j;

 BlockWrite(F, SpawnPoint_Start, sizeof(SpawnPoint_Start));


 {save spawnpoint}
 for i:= 1 to high(SpawnPoints) do
 if SpawnPoints[i].Active then
 begin
  SpawnPoint_New.SpawnPoint:= SpawnPoints[i];

  BlockWrite(F, SpawnPoint_New, sizeof(SpawnPoint_New));
 end;


 {save waypoint start}
 {clean}
 s:= '';
 for i:= 1 to high(Map.Path.Waypoint) do
 if (i>1)and(i<high(Map.Path.Waypoint)) then
 if Map.Path.Waypoint[i].Active then
 if not Map.Path.Waypoint[i-1].Active then
 if not Map.Path.Waypoint[i+1].Active then
  Map.Path.Waypoint[i].Active:= false;
 Map.Path.Waypoint[high(Map.Path.Waypoint)].active:= false;
 {end clean}



 j:= 0;
 for i:= high(Map.Path.Waypoint) downto 1 do
 if not Map.Path.Waypoint[i].Active then
  inc(j) else break;

 WayPoint_Start.Num:= high(Map.Path.Waypoint)-j;

 BlockWrite(F, WayPoint_Start, sizeof(WayPoint_Start));

 {save waypoint}
 for i:= 1 to WayPoint_Start.Num do
 begin
  WayPoint_New.WayPoint:= Map.Path.Waypoint[i];

  BlockWrite(F, WayPoint_New, sizeof(WayPoint_New));
 end;

 CloseFile(F);

 {s:= '';
 for i:= 1 to high(Map.Path.Waypoint) do
 if Map.Path.Waypoint[i].Active then
 s:= s+'1' else s:= s+'0';

 showmessage(s); }

end;



// -------------------------------------------------------------------
////////    MAP LOADING             ///////////////////////////////////
// -------------------------------------------------------------------
procedure TForm1.LoadFromFile2(filename : string);
var
 F : file;
 i, j, k : integer;
 x, y : integer;
 kolor : TColor;
 Header :  TMapFile_Header;
 Options :  TMapFile_Options;
 Polygon_Start : TMapFile_Polygon_Start;
 Polygon : TMapFile_Polygon;
 Sector_Start : TMapFile_Sector_Start;
 Sector_New : TMapFile_Sector_New;
 Sector_PolyNum : TMapFile_Sector_PolyNum;
 Prop_Start : TMapFile_Prop_Start;
 Prop_New : TMapFile_Prop;
 Scenery_Start : TMapFile_Scenery_Start;
 Scenery_New : TMapFile_Scenery;
 Collider_Start : TMapFile_Collider_Start;
 Collider_New : TMapFile_Collider;
 SpawnPoint_Start : TMapFile_SpawnPoint_Start;
 SpawnPoint_New : TMapFile_SpawnPoint;
 WayPoint_Start : TMapFile_WayPoint_Start;
 WayPoint_New : TMapFile_WayPoint;
 b : integer;
begin
  Compiled:= true;

 AssignFile(F, filename);
 Reset(F, 1);

 {load header}
 BlockRead(F, Header, sizeof(Header));

 {load options}
 BlockRead(F, Options, sizeof(Options));

  MapName.Text:= Options.MapName;

  Map.BackgroundColor:= Options.BackgroundColor;
  Map.BackgroundColor2:= Options.BackgroundColor2;

  kolor:= RGB(getBValue(Map.Backgroundcolor),getGValue(Map.Backgroundcolor),getRValue(Map.Backgroundcolor));
  ColorBox4.Selected:= kolor;
  kolor:= RGB(getBValue(Map.Backgroundcolor2),getGValue(Map.Backgroundcolor2),getRValue(Map.Backgroundcolor2));
  ColorBox5.Selected:= kolor;

  Map.LoadTexture(RootDirectory+'..\Textures\'+Options.TextureName);
  TexName:= Options.TextureName;

 JetBox.ItemIndex:= 7;
 case Options.StartJet of
  0 : JetBox.ItemIndex:= 0;
  12 : JetBox.ItemIndex:= 1;
  45 : JetBox.ItemIndex:= 2;
  95 : JetBox.ItemIndex:= 3;
  190 : JetBox.ItemIndex:= 4;
  320 : JetBox.ItemIndex:= 5;
  800 : JetBox.ItemIndex:= 6;
 end;
  JetBar.Position:= Options.StartJet;

 GrenadeBox.Text:= inttostr(Options.GrenadePacks);
 MedicBox.Text:= inttostr(Options.Medikits);
 WeatherBox.ItemIndex:= Options.Weather;
 StepBox.ItemIndex:= Options.Steps;


 {load polygon start}
 BlockRead(F, Polygon_Start, sizeof(Polygon_Start));

 Map.PolyCount:= Polygon_Start.PolyCount;


 {load polygons}
 for i:= 1 to Map.PolyCount do
 begin
  BlockRead(F, Polygon, sizeof(Polygon));

  Map.Polys[i]:= Polygon.Poly;
  for j:= 1 to 3 do
   Map.Perp[i][j]:= Polygon.Perp[j];

  Map.PolyType[i]:= Polygon.PolyType;
 end;


 {load sectors start}
 BlockRead(F, Sector_Start, sizeof(Sector_Start));

 Map.SectorsDivision:= Sector_Start.SectorsDivision;
 SECTOR_NUM:= Sector_Start.SectorNum;

 b:= 0;

 {load sectors}
 for x:= -SECTOR_NUM to SECTOR_NUM do
  for y:= -SECTOR_NUM to SECTOR_NUM do
  begin
   {load new sector}
   BlockRead(F, Sector_New, sizeof(Sector_New));

   Map.Sectors[x, y].PolyCount:= Sector_New.PolyCount;

    {load sectors polygon nums}
     for j:= 1 to Map.Sectors[x, y].PolyCount do
     begin
      BlockRead(F, Sector_PolyNum, sizeof(Sector_PolyNum));

      Map.Sectors[x, y].Polys[j]:= Sector_PolyNum.Polys;
     end;

   inc(b);
  end;


  with Map do
  begin
    BackPoly[1].Vertices[1]:= GetCustomVertex(NMIN_SECTOR*SectorsDivision,NMIN_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor, 0, 0);
    BackPoly[1].Vertices[2]:= GetCustomVertex(NMAX_SECTOR*SectorsDivision,NMIN_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor, 0, 0);
    BackPoly[1].Vertices[3]:= GetCustomVertex(NMAX_SECTOR*SectorsDivision,NMAX_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor2, 0, 0);
    BackPoly[2].Vertices[1]:= GetCustomVertex(NMAX_SECTOR*SectorsDivision,NMAX_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor2, 0, 0);
    BackPoly[2].Vertices[2]:= GetCustomVertex(NMIN_SECTOR*SectorsDivision,NMAX_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor2, 0, 0);
    BackPoly[2].Vertices[3]:= GetCustomVertex(NMIN_SECTOR*SectorsDivision,NMIN_SECTOR*SectorsDivision,0, 1, 0.0, 0.0, BackgroundColor, 0, 0);
  end;

  ColorBox4Change(nil); ColorBox5Change(nil);  

 {load prop start}
 BlockRead(F, Prop_Start, sizeof(Prop_Start));

 j:= Prop_Start.Num;


 {load prop}
 for i:= 1 to j do
 begin
  BlockRead(F, Prop_New, sizeof(Prop_New));

  Prop[i]:= Prop_New.Prop;
 { Prop[i].Active:= Prop_New.Prop.Active;
  Prop[i].Style:= Prop_New.Prop.Style;
  Prop[i].Width:= Prop_New.Prop.Width;
  Prop[i].Height:= Prop_New.Prop.Height;
  Prop[i].X:= Prop_New.Prop.X;
  Prop[i].Y:= Prop_New.Prop.Y;
  Prop[i].Rotation:= Prop_New.Prop.Rotation;
  Prop[i].ScaleX:= Prop_New.Prop.ScaleX;
  Prop[i].ScaleY:= Prop_New.Prop.ScaleY;
  Prop[i].Alpha:= Prop_New.Prop.Alpha;
  Prop[i].Color:= Prop_New.Prop.Color;
  Prop[i].Level:= Prop_New.Prop.Level;}
 end;

 {load scenery start}
 BlockRead(F, Scenery_Start, sizeof(Scenery_Start));

 {load scenery new}
  PropBox.Items.Clear;
  PropBox.Items.Add('');

   SceneryElements:= 0;

 for i:= 1 to Scenery_Start.Num do
 begin
  BlockRead(F, Scenery_New, sizeof(Scenery_New));

  AddCustomScenery(Scenery_New.Name);
 end;

 {load collider start}
 BlockRead(F, Collider_Start, sizeof(Collider_Start));

 j:= Collider_Start.Num;


 {load collider}
 for i:= 1 to j do
 begin
  BlockRead(F, Collider_New, sizeof(Collider_New));

  Collider[i]:= Collider_New.Collider;
 end;


 {load spawnpoint start}
 BlockRead(F, SpawnPoint_Start, sizeof(SpawnPoint_Start));

 j:= SpawnPoint_Start.Num;


 {load spawnpoint}
 for i:= 1 to j do
 begin
  BlockRead(F, SpawnPoint_New, sizeof(SpawnPoint_New));

  SpawnPoints[i]:= SpawnPoint_New.SpawnPoint;
 end;


 {load waypoint start}
 BlockRead(F, WayPoint_Start, sizeof(WayPoint_Start));

 j:= WayPoint_Start.Num;


 {load waypoint}
 for i:= 1 to j do
 begin
  BlockRead(F, WayPoint_New, sizeof(WayPoint_New));

  Map.Path.WayPoint[i]:= WayPoint_New.WayPoint;
  
 { Map.Path.WayPoint[i].Active:= WayPoint_New.WayPoint.Active;
  Map.Path.WayPoint[i].id:= WayPoint_New.WayPoint.id;
  Map.Path.WayPoint[i].X:= WayPoint_New.WayPoint.X;
  Map.Path.WayPoint[i].Y:= WayPoint_New.WayPoint.Y;
  Map.Path.WayPoint[i].left:= WayPoint_New.WayPoint.left;
  Map.Path.WayPoint[i].right:= WayPoint_New.WayPoint.right;
  Map.Path.WayPoint[i].up:= WayPoint_New.WayPoint.up;
  Map.Path.WayPoint[i].down:= WayPoint_New.WayPoint.down;
  Map.Path.WayPoint[i].m2:= WayPoint_New.WayPoint.m2;
  Map.Path.WayPoint[i].PathNum:= WayPoint_New.WayPoint.PathNum;
  Map.Path.WayPoint[i].ConnectionsNum:= WayPoint_New.WayPoint.ConnectionsNum;
  for k:= 1 to MAX_CONNECTIONS do
  Map.Path.WayPoint[i].Connections[k]:= WayPoint_New.WayPoint.Connections[k];

  Map.Path.WayPoint[i].C1:= 0;
  Map.Path.WayPoint[i].C2:= 0;
  Map.Path.WayPoint[i].C3:= 0;  }
 end;

 
 CloseFile(F);

   if not Map.UpdateVertexBuffer then begin hHalt(ERR03); exit; end;

   MakeUndo;
end;


procedure TForm1.JetBoxChange(Sender: TObject);
begin
 case JetBox.ItemIndex of
  0 : JetBar.Position:= 0;
  1 : JetBar.Position:= 12;
  2 : JetBar.Position:= 45;
  3 : JetBar.Position:= 95;
  4 : JetBar.Position:= 190;
  5 : JetBar.Position:= 320;
  6 : JetBar.Position:= 800;
 end;
end;

procedure TForm1.JetBarChange(Sender: TObject);
begin
 JetBox.ItemIndex:= 7;
 case JetBar.Position of
  0 : JetBox.ItemIndex:= 0;
  12 : JetBox.ItemIndex:= 1;
  45 : JetBox.ItemIndex:= 2;
  95 : JetBox.ItemIndex:= 3;
  190 : JetBox.ItemIndex:= 4;
  320 : JetBox.ItemIndex:= 5;
  800 : JetBox.ItemIndex:= 6;
 end;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
 PolyBox.ItemIndex:= Map.PolyType[ColPol];
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
 Map.PolyType[ColPol]:= PolyBox.ItemIndex;
end;

procedure TForm1.eam31Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 3;
end;

procedure TForm1.eam41Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 4;
end;

procedure TForm1.RedFlag1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 5;
end;

procedure TForm1.Blue1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 6;
end;

procedure TForm1.Grenades1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 7;
end;

procedure TForm1.Medikits1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 8;
end;

procedure TForm1.ClusterGrenades1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 9;
end;

procedure TForm1.BulletproofVest1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 10;
end;

procedure TForm1.FlamerBonus1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 11;
end;

procedure TForm1.BerserkerBonus1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 12;
end;

procedure TForm1.PredatorBonus1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 13;
end;

procedure TForm1.YellowFlag1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 14;
end;

procedure TForm1.RamboBow1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 15;
end;

procedure TForm1.SpecialListChange(Sender: TObject);
begin
 if MouseWaypoint>0 then
  Map.Path.WayPoint[MouseWayPoint].C1:= SpecialList.Itemindex;
end;

procedure TForm1.PageControlChange(Sender: TObject);
begin
  PropCreate:= false;
  ColliderCreate:= false;
  SpawnCreate:= false;
  WaypointsMake:= false;

case PageControl.TabIndex of
 2 :  WaypointsMake:= true;
end;

end;


procedure TForm1.MakeUndo;
begin
 {inc(UndoRound);
 if UndoRound>9 then} UndoRound:= 0;
 SaveToFile2(ExtractFilePath(ParamStr(0))+'\Temp\'+'_undo'{+inttostr(UndoRound)}+'.pms');
end;


procedure TForm1.SceneryFilesChange(Sender: TObject);
begin
 if (SceneryFiles.ItemIndex<0)or(SceneryFiles.ItemIndex>SceneryFiles.Items.Count-1) then exit;

 SceneryImage.Picture.LoadFromFile(RootDirectory+'..\Scenery-gfx\'+SceneryFiles.Items.Strings[SceneryFiles.ItemIndex]);

 PropBox.ItemIndex:= 0;
end;


procedure TForm1.AddCustomScenery(filename : string);
var
 II : TD3DXImageInfo;
 i : integer;
begin
 PropBox.Items.Add(filename);
 PropBox.ItemIndex:= PropBox.Items.Count-1;

  inc(SceneryElements);
  SceneryTexture[SceneryElements]:= nil;
  if not xLoadTexture(RootDirectory+'..\Scenery-gfx\'+filename,  $FF00FF00, SceneryTexture[SceneryElements]) then exit;
  D3DXGetImageInfoFromFileA(pchar(RootDirectory+'..\Scenery-gfx\'+filename), II); SWidth[SceneryElements]:= II.Width; SHeight[SceneryElements]:= II.Height;

end;


procedure TForm1.AddCustomSceneryButtonClick(Sender: TObject);
var
 II : TD3DXImageInfo;
 i : integer;
begin
 if (SceneryFiles.ItemIndex<0)or(SceneryFiles.ItemIndex>SceneryFiles.Items.Count-1) then exit;

 for i:= 0 to PropBox.Items.Count-1 do
  if PropBox.Items.Strings[i]=SceneryFiles.Items.Strings[SceneryFiles.ItemIndex] then
  begin
   showmessage('Scenery file already in list');
   exit;
  end;

 AddCustomScenery(SceneryFiles.Items.Strings[SceneryFiles.ItemIndex]);
end;


function CheckFileDate(filename : string):integer;
var sr:tsearchrec;
begin
// if  findfirst(filename, faanyfile, sr) =0  then
//     showmessage('Wielko pliku : '+inttostr(sr.size));

 findfirst(filename, faanyfile, sr);

  Result:= sr.Time;
 FindClose(sr);
end;

procedure TForm1.ToolButton11Click(Sender: TObject);
var j : integer;
begin
 MakeUndo;

 if MultiPolNum>0 then
 begin

  if MultiPolNum>0 then
  begin
   for j:= 1 to MultiPolNum do
   begin

     Map.Polys[MultiPol[j]].Vertices[1]:= GetCustomVertex(Map.Polys[MultiPol[j]].Vertices[1].X, Map.Polys[MultiPol[j]].Vertices[1].Y, 1, 1, 0.0, 0.0, Map.Polys[MultiPol[j]].Vertices[1].DColor, Camera.X, Camera.Y);
     Map.Polys[MultiPol[j]].Vertices[2]:= GetCustomVertex(Map.Polys[MultiPol[j]].Vertices[2].X, Map.Polys[MultiPol[j]].Vertices[2].Y, 1, 1, 0.0, 0.0, Map.Polys[MultiPol[j]].Vertices[2].DColor, Camera.X, Camera.Y);
     Map.Polys[MultiPol[j]].Vertices[3]:= GetCustomVertex(Map.Polys[MultiPol[j]].Vertices[3].X, Map.Polys[MultiPol[j]].Vertices[3].Y, 1, 1, 0.0, 0.0, Map.Polys[MultiPol[j]].Vertices[3].DColor, Camera.X, Camera.Y);
   end;

     UpdateSelPolys;
  end;

  Map.UpdateVertexBuffer;
 end else
 if ColPol>0 then
 begin
  Map.Polys[ColPol].Vertices[1]:= GetCustomVertex(Map.Polys[ColPol].Vertices[1].X, Map.Polys[ColPol].Vertices[1].Y, 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[1].DColor, Camera.X, Camera.Y);
  Map.Polys[ColPol].Vertices[2]:= GetCustomVertex(Map.Polys[ColPol].Vertices[2].X, Map.Polys[ColPol].Vertices[2].Y, 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[2].DColor, Camera.X, Camera.Y);
  Map.Polys[ColPol].Vertices[3]:= GetCustomVertex(Map.Polys[ColPol].Vertices[3].X, Map.Polys[ColPol].Vertices[3].Y, 1, 1, 0.0, 0.0, Map.Polys[ColPol].Vertices[3].DColor, Camera.X, Camera.Y);

  Map.UpdateVertexBuffer;
 end;

end;

procedure TForm1.StretchClick(Sender: TObject);
begin
 MakeUndo;

end;

procedure TForm1.DarkenClick(Sender: TObject);
begin
 MakeUndo;

end;

procedure TForm1.LightenClick(Sender: TObject);
begin
 MakeUndo;

end;

procedure TForm1.ToolButton13Click(Sender: TObject);
begin
 if ToolButton13.Down then HelpPanel.Show else HelpPanel.Hide;
end;

procedure TForm1.ZoomBarChange(Sender: TObject);
var
 X, Y : single;
begin
 X:= ZX; Y:= ZY;

 ZX:= ZoomBar.Position/{266.66666}200;
 ZY:= ZoomBar.Position/200;

 Camera.X:= round(Camera.X*(ZX/X));
 Camera.Y:= round(Camera.Y*(ZY/Y));

end;

procedure TForm1.ZoomButtonClick(Sender: TObject);
var
 X, Y : single;
begin
 X:= ZX; Y:= ZY;

if Zoom>0 then
begin
 Camera.X:= OldCX; Camera.Y:= OldCY;

 Zoom:= 0;
 ZX:= 1;
 ZY:= 1;
 ZoomButton.Caption:= 'Zoom';
 ZoomBar.Enabled:= false;
end else
begin
 Camera.X:= OldZCX; Camera.Y:= OldZCY;

 Zoom:= 1;
 ZX:= ZoomBar.Position/{266.66666}200;
 ZY:= ZoomBar.Position/200;
 ZoomButton.Caption:= 'Unzoom';
 ZoomBar.Enabled:= true;
 X:= ZX; Y:= ZY;
end;

 {Camera.X:= round(Camera.X*(ZX/X));
 Camera.Y:= round(Camera.Y*(ZY/Y));     }
end;

///////////    COPY ///
procedure TForm1.CopyButtonClick(Sender: TObject);
var
 i : integer;
begin
 CopyPolyCount:= MultiPolNum;

 {sel}
 if CopyPolyCount>0 then
 for i:= 1 to MultiPolNum do
 begin
  CopyPoly[i]:= Map.Polys[MultiPol[i]];
  CopyPoly[i].Vertices[1].X:= CopyPoly[i].Vertices[1].X-Camera.X;
  CopyPoly[i].Vertices[2].X:= CopyPoly[i].Vertices[2].X-Camera.X;
  CopyPoly[i].Vertices[3].X:= CopyPoly[i].Vertices[3].X-Camera.X;
  CopyPoly[i].Vertices[1].Y:= CopyPoly[i].Vertices[1].Y-Camera.Y;
  CopyPoly[i].Vertices[2].Y:= CopyPoly[i].Vertices[2].Y-Camera.Y;
  CopyPoly[i].Vertices[3].Y:= CopyPoly[i].Vertices[3].Y-Camera.Y;
  CopyPolyType[i]:= Map.PolyType[MultiPol[i]];
 end;

 {one}
 if CopyPolyCount=0 then
 if ColPol>0 then
 begin
  CopyPolyCount:= 1;
  CopyPoly[1]:= Map.Polys[ColPol];
  CopyPolyType[1]:= Map.PolyType[ColPol];
 end;
end;


///////////    PASTE ///
procedure TForm1.PasteButtonClick(Sender: TObject);
var
 i : integer;
begin
 if CopyPolyCount<1 then exit;

 MakeUndo;
 MultiPolNum:= 0;

 for i:= 1 to CopyPolyCount do
 begin
  inc(Map.PolyCount);
  inc(MultiPolNum);

  Map.Polys[Map.PolyCount].Vertices[1] := GetCustomVertex(round(Camera.X+CopyPoly[i].Vertices[1].X), round(Camera.Y+CopyPoly[i].Vertices[1].Y), 1, 1, CopyPoly[i].Vertices[1].tu, CopyPoly[i].Vertices[1].tv, CopyPoly[i].Vertices[1].DColor, Camera.X, Camera.Y);
  Map.Polys[Map.PolyCount].Vertices[2] := GetCustomVertex(round(Camera.X+CopyPoly[i].Vertices[2].X), round(Camera.Y+CopyPoly[i].Vertices[2].Y), 1, 1, CopyPoly[i].Vertices[2].tu, CopyPoly[i].Vertices[2].tv, CopyPoly[i].Vertices[2].DColor, Camera.X, Camera.Y);
  Map.Polys[Map.PolyCount].Vertices[3] := GetCustomVertex(round(Camera.X+CopyPoly[i].Vertices[3].X), round(Camera.Y+CopyPoly[i].Vertices[3].Y), 1, 1, CopyPoly[i].Vertices[3].tu, CopyPoly[i].Vertices[3].tv, CopyPoly[i].Vertices[3].DColor, Camera.X, Camera.Y);
  Map.PolyType[Map.PolyCount]:= CopyPolyType[i];
  CalcPerps(Map.PolyCount);

  MultiPol[MultiPolNum]:= Map.PolyCount;
 end;

 Map.UpdateVertexBuffer;
 UpdateSelPolys;
end;

procedure TForm1.Button9Click(Sender: TObject);
var
 OX, OY : single;
 i : integer;
begin
 CopyPolyCount:= MultiPolNum;

 {sel}
 if CopyPolyCount>0 then
 begin

  OX:= (Map.Polys[MultiPol[1]].Vertices[1].X+Map.Polys[MultiPol[1]].Vertices[2].X+Map.Polys[MultiPol[1]].Vertices[3].X)/3;

  for i:= 1 to MultiPolNum do
  begin

   Map.Polys[MultiPol[i]].Vertices[1].X:= 2*OX-Map.Polys[MultiPol[i]].Vertices[1].X;
   Map.Polys[MultiPol[i]].Vertices[2].X:= 2*OX-Map.Polys[MultiPol[i]].Vertices[2].X;
   Map.Polys[MultiPol[i]].Vertices[3].X:= 2*OX-Map.Polys[MultiPol[i]].Vertices[3].X;
   CalcPerps(MultiPol[i]);
  end;

  UpdateSelPolys;
 end;

 {one}
 if CopyPolyCount=0 then
 if ColPol>0 then
 begin
  OX:= (Map.Polys[ColPol].Vertices[1].X+Map.Polys[ColPol].Vertices[2].X+Map.Polys[ColPol].Vertices[3].X)/3;

  Map.Polys[ColPol].Vertices[1].X:= 2*OX-Map.Polys[ColPol].Vertices[1].X;
  Map.Polys[ColPol].Vertices[2].X:= 2*OX-Map.Polys[ColPol].Vertices[2].X;
  Map.Polys[ColPol].Vertices[3].X:= 2*OX-Map.Polys[ColPol].Vertices[3].X;
  CalcPerps(ColPol);
 end;

 Map.UpdateVertexBuffer;

end;

procedure TForm1.Button10Click(Sender: TObject);
var
 OX, OY : single;
 i : integer;
begin
 CopyPolyCount:= MultiPolNum;

 {sel}
 if CopyPolyCount>0 then
 begin

  OY:= (Map.Polys[MultiPol[1]].Vertices[1].Y+Map.Polys[MultiPol[1]].Vertices[2].Y+Map.Polys[MultiPol[1]].Vertices[3].Y)/3;

  for i:= 1 to MultiPolNum do
  begin

   Map.Polys[MultiPol[i]].Vertices[1].Y:= 2*OY-Map.Polys[MultiPol[i]].Vertices[1].Y;
   Map.Polys[MultiPol[i]].Vertices[2].Y:= 2*OY-Map.Polys[MultiPol[i]].Vertices[2].Y;
   Map.Polys[MultiPol[i]].Vertices[3].Y:= 2*OY-Map.Polys[MultiPol[i]].Vertices[3].Y;
   CalcPerps(MultiPol[i]);
  end;

  UpdateSelPolys;
 end;

 {one}
 if CopyPolyCount=0 then
 if ColPol>0 then
 begin
  OY:= (Map.Polys[ColPol].Vertices[1].Y+Map.Polys[ColPol].Vertices[2].Y+Map.Polys[ColPol].Vertices[3].Y)/3;

  Map.Polys[ColPol].Vertices[1].Y:= 2*OY-Map.Polys[ColPol].Vertices[1].Y;
  Map.Polys[ColPol].Vertices[2].Y:= 2*OY-Map.Polys[ColPol].Vertices[2].Y;
  Map.Polys[ColPol].Vertices[3].Y:= 2*OY-Map.Polys[ColPol].Vertices[3].Y;
  CalcPerps(ColPol);
 end;

 Map.UpdateVertexBuffer;

end;

procedure TForm1.Stationarygun1Click(Sender: TObject);
begin
 SpawnCreate:= true;
 SpawnTeam:= 16;
end;

end.
